Package: netboost
Type: Package
Title: Network Analysis Supported by Boosting
Version: 2.19.0
Date: 2024-06-12
Authors@R: c(person("Pascal", "Schlosser", role = c("aut", "cre"),
                    email = "pascal.schlosser@uniklinik-freiburg.de"),
             person("Jochen", "Knaus", role = c("aut", "ctb"),
                    email = "jo@imbi.uni-freiburg.de"),
             person("Yaniv", "Loewenstein", role = c("aut")))
Description: Boosting supported network analysis for high-dimensional omics applications. 
    This package comes bundled with the MC-UPGMA clustering package by Yaniv Loewenstein.
Depends: R (>= 4.0.0)
biocViews: Software, StatisticalMethod, GraphAndNetwork, Network,
        Clustering, DimensionReduction, BiomedicalInformatics,
        Epigenetics, Metabolomics, Transcriptomics
Imports: Rcpp, RcppParallel, parallel, grDevices, graphics, stats,
        utils, dynamicTreeCut, WGCNA, impute, colorspace, methods,
        BiocStyle, R.utils
LinkingTo: Rcpp, RcppParallel
Suggests: knitr, rmarkdown
VignetteBuilder: knitr
SystemRequirements: GNU make, Bash, Perl, Gzip
OS_type: unix
ByteCompile: yes
NeedsCompilation: yes
LazyData: true
License: GPL-3
URL: https://bioconductor.org/packages/release/bioc/html/netboost.html
BugReports: pascal.schlosser@uniklinik-freiburg.de
Encoding: UTF-8
RoxygenNote: 7.2.3
git_url: https://git.bioconductor.org/packages/netboost
git_branch: devel
git_last_commit: cd295da
git_last_commit_date: 2025-10-29
Repository: Bioconductor 3.23
Date/Publication: 2025-10-30
Packaged: 2025-10-30 22:11:46 UTC; biocbuild
Author: Pascal Schlosser [aut, cre],
  Jochen Knaus [aut, ctb],
  Yaniv Loewenstein [aut]
Maintainer: Pascal Schlosser <pascal.schlosser@uniklinik-freiburg.de>

# Netboost
Boosting supported network analysis for high-dimensional omics applications.
The corresponding publication has been published in IEEE TCBB:

Pascal Schlosser, Jochen Knaus, Maximilian Schmutz, Konstanze Döhner, Christoph Plass, Lars Bullinger, Rainer Claus, Harald Binder, Michael Lübbert and Martin Schumacher, Netboost: Boosting-supported network analysis improves high-dimensional omics prediction in acute myeloid leukemia and Huntington's disease, IEEE/ACM Trans Comput Biol Bioinform (2021): 10.1109/TCBB.2020.2983010.

This package comes bundled with the MC-UPGMA clustering package by Yaniv Loewenstein.

# Requirements
This package is only working on MacOS and Linux (no Windows atm).

Required for building are C/C++ compilers, GNU make, GZIP, Perl.

# Installation
```
if (!requireNamespace("BiocManager", quietly = TRUE))
    install.packages("BiocManager")
BiocManager::install("netboost", version = "3.12")
```

# Example
```R
browseVignettes("netboost")
```

# Contact
If you have any issues using the package then please get in touch with Pascal Schlosser (pascal.schlosser at uniklinik-freiburg.de).
Bug reports etc are most welcome, we want the package to be easy to use for everyone!

============================================================================================
=========    User guide for the multi-round MC-UPGMA clustering package          ===========
=========                                                                        ===========
=========         Yaniv Loewenstein,  Copyright (C), September 2008              ===========
=========                                                                        ===========
============================================================================================

This package is supplied on an as is basis. This guide assumes that you are familiar with hierarchical clustering, 
and have good knowledge of Unix based systems. You can look at the the MC-UPGMA paper to get a broad idea of the 
memory constrained concept, the multi-round scheme, and what are M, psi and other parameters. However, you by no 
means need to know all the nitty gritty clustering details.



==================================================
===== Installation                 ===============
==================================================

to install the package use: (after you have uncompressed the distribution tarball)
% make install
% make configure
% make test

==================================================
===== Clustering                 =================
==================================================
Use the cluster.pl script in the scripts directory to run the clustering process. Run it with the -help option to 
see how to specify parameters. The options specification is also given in this manual for reference.

==================================================
===== Input format                 ===============
==================================================

1. Your input edges should appear in gzipped input files, where the filenames have the extension edges.gz.

2. Input format: three fields per input line, white-space delimited in the format: 'cluster_id1 cluster_id2 distance',
   where cluster_id1 and cluster_id2 are positive integers identifying clusters (initially, your clustered 
   data-items are the singleton clusters) and distances are given in double precision (typically, non-negative 
   numbers). Note that cluster IDs must be > 0 (strictly positive).

3. Lower dissimilarities mean closer items, i.e. "i j 1e-20" will be clustered before "k l 0.005"

3. If you are using the parallelization capabilities of clustering package, it is recommended that break the input 
into several files (e.g. part1.edges.gz .. part10.edges.gz), since each could be processed in parallel to the 
others. 

	==================
	== IMPORTANT ! ===
	==================

	Assumptions on input:

	A. Self edges are not allowed, i.e cluster_id1 == cluster_id2 is illegal. These self similarities are 
	   irrelevant for clustering purposes. 
	B. It is illegal to include both edges i<->j and j<->i and it will lead to unexpected clustering failures. 
	   The similarities between cluster pairs are direction-less (or symmetric), thus it is sufficient to 
	   include only one direction, e.g. requiring that cluster_id1 < cluster_id2 for all edges. 
	C. It is illegal to include edges >= psi, your max_distance command line argument by psi's definition.  It 
	   will lead the clustering process to exit with an error code, since it may not be able to cluster these 
	   edges, thus failing to normally complete the process. 
	D. All cluster IDs are > 0 integers.
	E. Missing edges are allowed, and are assumed to be equal psi when computing averages across clusters.

	For instance, the input:
	
	1	1	0.0
	1	2	1e-20
	1	3	20
	2	1	1e-20
	2	4	110
	
	is illegal, due to the self edge 1<->1, and the appearance of both 1<->2 and 2<->1. Note that the edge 3<->4 
	is legally missing in this case of sparse input graph (i.e. some pairwise similarities are missing).

==================================================
===== Output format                 ==============
==================================================

The output tree is given in 4 fields per line format:'cluster_id1 cluster_id2  distance cluster_id3'. Each line 
defines one merge of two clusters in the binary clustering tree. cluster_id1 and cluster_id2 identify the pair of 
merged clusters, while cluster_id3 is an identifier for a new cluster - their union. cluster_id3 will appear later 
on as one of the two first fields when it is merged as well. This format resembles the output format of the matlab 
command 'linkage', with an additional 4th field to ease up its parsing. Note that sparse inputs containing more than 
one connected component in the input similarity graph, will yield a forest (several disjoint trees) by definition, 
rather than a strict tree. Note that if you are using the non-dendrogram output option, the given merge scores are 
not exact any more.


==================================================
====== Special notes                    ==========
==================================================

1. You will need write permissions into the present working directory (pwd). 
	The per round data, will be written into newly created per round directories in the pwd, while the overall 
        tree is built cumulatively by concatenating tree parts from consecutive rounds. 

2. You will need ample disk space to hold intermediate files needed by the multi-round clustering process in the pwd. 
	Surviving edges are passed from round to round, requiring significant disk space per round, and some 
	intermediate files are temporarily held uncompressed. If you by no means can afford enough disk space, and 
	you do understand the mechanism of the multi-round clustering process you can try and shortcut the process, 
	to eliminate some of this overhead, e.g. by concatenating several tree parts into one "virtual" larger round etc.

3. If the clustering process fails midway for some reason, you can re-run the clustering program, and it will 
	automatically continue from the round it stopped at. 
	This capability is achieved by leveraging the makefile mechanism to manage dependencies between 
	per-round input and output files, and correct parallel execution based on temporal dependencies. 
	Hence, modifying the timestamps of these files (e.g. by moving individual files etc.) 
	** is prohibited **, since it may temper with correct order of file modification times, hence invalidating 
	the correct dependencies and breaking the whole process.

==================================================
===== Troubleshooting                 ============
==================================================

1. Run through the clustering log produced by the clustering script.
	- Search for errors and warnings. 
	- Make sure that the required programs are up and running.
	- Make sure that you have required software and programs (e.g. Perl interpreter is in /usr/bin/perl etc.)
2. Check your file-system settings.
	- Check that you have read-write permissions.
	- Check that you are not out of disk space.
3. Double and triple check your input.
	- Make absolutely sure that you have no self-edges, repeated edges i<->j and j<->i, zero indices, or edges >= psi.
4. Read the error messages and warnings and try to understand what went wrong. Reproduce the error for a minimal example. 
 	- Find the error source using the log. The exact command that led to the error, also appears in the log 
	output. You can use it in order to reproduce the error from an individual program. Narrow down the input, to 
	a minimal example which produces the error. Check that your input is legal. Try to reproduce the error on 
	another system, i.e. a different architecture, OS, disk etc. If you have done all this, and have a minimal 
	example for which you are sure you can reproduce the bug, e-mail it to me, and I will try to help. However, 
	note that THIS PACKAGE IS GIVEN ON AN AS-IS BASIS, thus I can not assure that I will be able to assist you.

===================================================
====== Portability                 ================
===================================================

This package should be compatible to any Unix system which supports GNU make, Perl and POSIX C/C++. 
I have tested the clustering process on Linux 32bit/64bit, FreeBSD, and Mac-Darwin architectures. 

===================================================
====== Clustering speed and choice of       =======
======	parameters - some rules of thumb.   =======
===================================================

==================================
== Data-dependent speed: =========  
==================================
In the paper we show how more "civilized" similarities (metric, or close to being 
metric), produce better clustering progress requiring far less rounds of clustering. Thus do not expect speedy 
clustering of completely random data. The clustering algorithm and code are specifically optimized for sparse inputs. However the correct solution is guaranteed for non-sparse inputs as well. You might want to use some pre-processing transformation to your dissimilarity data, as the clustering is most efficient when the data is exponentially distributed (i.e. dissimilarities appear in multiple scales of magnitude, as in BLAST E-values).

==================================
=== Choices affecting speed:    == 
==================================

Your choice of parameter values affects the overall required time. You can 
control the maximum number of parallel jobs, and allow more efficient processing by breaking the input into smaller 
chunks that can be processed in parallel. There is a tradeoff however, breaking the process into too many pieces 
takes its toll in increased overhead for processing each and every part separately. 

By default, the clusterer code currently demands that the merged minimal edge interval is exact. This allows to output 
each cluster-merge height, i.e. the merge score, to construct a full dendrogram. In many cases however, the tree 
topology is sufficient, and the user is not interested in the actual underlying merge scores. In these cases, it is 
possible to demand a less stringent stop-criterion allowing further clustering per round, thus speeding up the 
whole process. Once, the tree is given, it is rather easy to compute the exact merge scores in retrospect using a 
linear space (in the number of clustered objects) algorithm [1]. To speed up the process, you can also allow non 
dendrogram output (which does not require knowledge of the exact merge score) to allow further clustering per round 
(use `cluster.pl -help` for more info).

Make sure you specify a value for the -max_singleton option of cluster.pl. Otherwise, the script will 
determine it using another pass on the whole huge data, thus slowing down the initialization of the clustering 
considerably, when the data is very large. To improve memory performance, use dense indices, i.e. a tight 
-max_singleton value, and preferably consecutive indices for your input singleton clusters.

Good values for the MC-UPGMA parameters are as follows:

	- For the -jobs option (maximum number of parallel jobs) you should specify the number 
	of available CPUs. Too large values will clog your system with more concurrent processes that it can 
	efficiently serve. Smaller values will leave some of your processors idle. If you are using grid computing, 
	choose a value that will not swamp your grid with too many processes. 

	- For the -k option which allows splitting of edges files, choose a value similar to the number of 
  	concurrent jobs, larger values will lead to over-fragmentation of the files which could not be processed in 
	parallel to begin with. 

	- Selection of the value of H, the number of merging processes (or hashing buckets) is more delicate, since 
	the memory constraint is not explicitly coded into the merging processes. Choosing too large values of H, 
	with huge data which is orders of magnitude larger than the amount of available physical RAM, will lead to the 
	merging processes exiting abnormally with out of memory errors. Hence, make sure that you select a value 
	of H, such that your data-size (after some clustering) divided by H, should roughly fit into memory. Also 
	note that if you are running many process in parallel, sharing the same physical memory, you will have less 
	memory available per process. 
	If you 	have selected too small values, you will get noticeable out of memory errors in your clustering log. Too 
	large values will again lead to a slow down due over fragmentation. For 1.5G edges after pre-processing 
	(unique, non self edges where i<j), amounting to about 7GB of gzipped data, values of H of around 
	20-40 were just fine. Values around 10 produced too large chunks to fit into memory, using 4 parallel 
	process sharing the same 4GB RAM 32bit Linux machine.

	- Memory constraint M - Use your system monitoring capabilities (e.g. top or ps on Unix) to find just
	how many edges can be held effectively on your architecture (you can run the clustering executable 
	directly to do that, if you wish). The higher the value of M, the less rounds are required to complete the 
	clustering. This is since (1) further clustering progress is possible per round, and (2) the whole remaining 
	data will fit into memory earlier (when this happens, the clustering is completed in the same instant 
	round).
	The value of M ranges from a few million edges on a small RAM machine, to several hundred million edges on 
	state of the art 64bit architectures with several GB of physical RAM. In my experiments, about 40M edges  
	can be held on 4 GB RAM 32bit Linux machine, or 100M with 8 GB RAM 64bit Linux machine. 
	Do not rely on virtual memory (swap space) to choose higher value of M, paging algorithms (that manage 
	virtual memory) do not perform well for the clustering due to its non sequential nature. 

	- psi (the max distance argument) - use a tight bound on your maximal distances. Tighter bounds lead to less
	  intervals collisions allowing further clustering per round.

==================================================
=====     License                  ===============
==================================================
This source code is distributed under the terms of the GNU General Public License. See the file LICENSE for details.  
All rights reserved. 

===================================================
=====    Reference                      ===========
===================================================

If you find this code useful, please cite:

Loewenstein Y, Portugaly E, Fromer M, Linial M.
Efficient algorithms for accurate hierarchical clustering of huge datasets: tackling the entire protein space.
Bioinformatics. 2008 Jul 1;24(13):i41-9.



===================================================
=== cluster.pl options (see `cluster.pl -help`)  ==
===================================================
cluster.pl [-help] [-log_file <FILE>] [-verbose|-noverbose]   *.edges.gz
Runs MC-UPGMA multi-round clustering makefiles.

The clustering is done in iterations. In each iteration the minimal M edges are loaded,
and clustering is done to the point where correctness (i.e. as in O(|E|) memory regular UPGMA)
can no longer be guaranteed.

Input edges filenames must be have the extension .edges.gz and be gzipped.

Self edges, and duplicate edges (the edges i,j and j,i are also regarded duplicates) are not allowed as input, and
will lead to undefined behavior (crashes) . It is the user's responsibility to eliminate these cases.

The multi-round clustering process, is based on the makefile mechanism which evaluates dependencies
between input and output files, and on their modification timestamps. Therefor, modifying file
timestamps externally (by the user, not by this program) may invalidate the process, and is not
recommended.

Use dense cluster IDs to improve performance.

Configurable Parameters:


   -max_distance|x|psi <FLOAT> - Upper bound on all distance in input, used as missing edge's distance. Specification of
                                this option is mandatory.

   -max_singleton <UINT> - maximum cluster ID in input (>0). Can be any number N s.t. N > n for any input singleton ID n.
                          N+1 is the first merger ID. Dense

   -iterations <UINT>     - maximum number of clustering iterations.

   -M|heap_size  <UINT>   - maximum number of edges to load in a clustering iteration (dictated by hardware limits)
                            the larger M, the less clustering iterations needed.

                         ** NOTE: **  order of the input files specification is important when this option is used.

   -H|num_hash_buckets <UINT>  - how many output files of "thin" edges per input

   -jobs <UINT>          - run make with -j for parallelization (default: none). The value of this parameter is passed to
                          make's '-j' option. This option allows a considerable speed-up by parallelization of the
                          'external merging' procedures on a multi-processor machine.

   -retries <UINT>       - if make returns with an an error code, retry this number of times (default: 0)

   -otree|output_tree_file <FILE>         - output tree filename (default: cluster_tree)

   -split_unmodified_edges|k <INT>  - When this option is set, the file containing the unmodified cluster edges
                                     passed from round to round is split into k parts, each part can then be
                                     be processed in parallel to speed-up the process on a multi-processor machine.
                                     This is useful when this file contains the vast majority of the data and
                                     becomes the bottleneck, e.g. when very little clustering is done per round. An
                                     optimal value for k would be the number of concurrent jobs passed to the -jobs
                                     option.
Advanced options:

   -allow_non_dendrogram -  Allows merging of provably minimal edge intervals, even if the exact merge score
                            (cluster height in dendrogram) is not known at merge time due to partial knowledge
                            implied by the memory constraint. This option allows further clustering per round,
                            thus speeding up the whole clustering process considerably, by posing a less strict
                            requirement on the output - now the cluster heights are no longer required to be exact.
                            Note that this renders the cluster heights (merge scores) in the output tree
                            meaningless. It does preserve the correct tree topolgy of the clustering solution
                            however, and provides a useful speedup if don't need the dendrogram.

   -[no]sorted          - Assume input is sorted, uses unix's `head -M` to prevent reading all files by clustering
                          code, currently only applies to first iteration, since output of merging is not resorted.

   -mosix               - Run external parallel merging code under mosix (currently, only the native processes are
                          mosrun'ed. not the zcat). This capability is still half-baked, since most IO is done
                          through pipes, which are inefficeinet using mosix. We need to use mospipe in the *.mk
                          files to make the whole multi-round process efficient under mosix.

   -scriptsdir <DIR> - Use this directory for auxiliary scripts and makefiles, instead of using the same directory as this script's
                       location (i.e. scripts/)

   -[no]filesizes    - Print the filesizes (in bytes) of input edge files per round (default: toggled) . This may slow
                       down the round post-processing. It is useful for monitoring the rate in which the cluster similarity
                       graph shrinks, or for identifying situations in which little or no clustering is done per round (e.g. when debugging).

   -start|t|T <INT>     - jump start from iteration T (don't run make for iterations < T).  Useful when debugging.

Dependencies:
  clustering.mk - clustering Makefile (which uses other makefiles as well).
  wc            - standard unix word count
  smart_cat     - perl script choosing zcat if filename ends with .gz, cat otherwise.
  seq           - unix executable




------------------------------------------------------------------------------------------

[1] - You can do this by mapping input edges to specific merges-clusters which are the least common ancestor (LCA) in the clustering tree, for each pair of leafs in the input edges. Holding a constant number of sufficient statistics per cluster, allows to calcuate merge scores (e.g. arithmetic averages, maximum etc.) in retrospect.

#' Build of the mcupgma executables inplace and copy them to temp build.
#' Basically, the build using make is not perfect here, but also has
#' advantages: no own Makefile for the Rcpp parts is required (default is
#' safer). As mcupgma has a fixed Makefile without dependencies, but given
#' options, basically a rewrite would be required to inject the R compiler
#' settings.
#' This leaves "make" as only hard dependency (and running *nix).
#' C/C++ compiler settings from OS/defaults.
#'
#' Oct 2017, jo

#' Internal helper: create visible error messages.
nbErrorMsg <- function(msg="") {
    row <- paste0(rep("*", 70), collapse = "")

    return(paste0(c("", row, msg, row, ""), collapse = "\n", sep = ""))
}

#' Internal helper: check if a given program is installed
#' (simple check: calling creates an error)
nbCheckPrg <- function(prg, txt) {
    # Check if program is present (all feature --version or ignore it)
    program <- tryCatch(system2(prg, "--version",
                                stdout = TRUE, stderr = TRUE),
                        error=function(err) NULL)

    if (is.null(program))
        return(paste(txt, " not installed (call '", prg, "')", sep=""))
    else
        return(NULL)
}

# Should never be reached, as in DESCRIPTION and .BBSoptions.
if (WINDOWS)
    stop(nbErrorMsg("mcupgma build on Windows is currently not supported"))

# Check if required prequisites for mcupgma are all available
# (as in SystemRequirements in DESCRIPTION + others)
cnt <- c(nbCheckPrg("make", "(GNU) make"),
         nbCheckPrg("bash", "Bash shell"),
         nbCheckPrg("perl", "Perl interpreter"),
         nbCheckPrg("echo", "echo shell command"))
#         nbCheckPrg("gzip", "GZip packer"),

# Any missings?
if (length(cnt) > 0) {
    # List formating could be done more elegant...
    cnt[1] <- paste0("- ", cnt[1])
    stop(nbErrorMsg(gsub("\n$", "", perl = TRUE,
                         paste0(cnt, sep = "\n", collapse = "- "))))
}

# Those variables are coming from R.
print(paste("R_PACKAGE_SRC: ", R_PACKAGE_SOURCE))
print(paste("R_PACKAGE_DIR: ", R_PACKAGE_DIR))
print(paste("R_ARCH:        ", R_ARCH))
print(paste("SHLIB_EXT:     ", SHLIB_EXT))

## mcupgma lying in src folder
src_mcupgma  <- file.path(R_PACKAGE_SOURCE, 'src', 'mcupgma')

## Destination path of R package
dest_lib <- file.path(R_PACKAGE_DIR, paste0('libs', R_ARCH))

## MCUPGMA folder (binaries, scripts and additional files)
dest_mcupgma <- file.path(R_PACKAGE_DIR, 'mcupgma')

print(paste("INSTALL PATH: ",
            file.path(src_mcupgma, "scripts", "install_path.mk")))

## Original MCUPGMA Makefile: create installation path as separate file with
## only export of variable INSTALL_PATH.
## @TODO Replace with R file writing.
system2("echo", paste0("export INSTALL_PATH := ",
                       dest_mcupgma,
                       " > ",
                       file.path(src_mcupgma, "scripts", "install_path.mk")))

## Build mcupgma package (package builds itself in own folder)
retMake1 <- system2(command = "make",                ## Clean
                    args = c(paste0("-C ", src_mcupgma),
                             "-f Makefile", 
                             "clean"))

## Stop on error (default)
if (retMake1 != 0)
    stop(nbErrorMsg("Build mcupgma: make clean failed"))

## Build all.
retMake2 <- system2(command = "make",
                    args = c(paste0("-C ", src_mcupgma),
                             "-f Makefile", 
                             "all"))

if (retMake2 != 0)
    stop(nbErrorMsg("Build mcupgma: make all failed"))

## TODO Add checks.
print(paste("SRC: ", src_mcupgma))
print(paste("DEST:", dest_mcupgma))

if (!dir.create(dest_mcupgma, recursive = TRUE, showWarnings = TRUE))
    stop(nbErrorMsg(paste("Unable to create:", dest_mcupgma)))

## Executables created in two directories (clustering_round and
## clustering_utils) plus some Shell/Perl scripts in directory
## scripts.
## (Many file probes here, incl. dublicates, but less than 20
## files so no problem)
for (path in c(file.path('clustering_round', 'bin'),
               file.path('clustering_util', 'bin'),
               file.path('scripts'))) {
    ## Source folder
    copy_path <- file.path(src_mcupgma, path)

    ## All files in folder
    files <- list.files(path = copy_path, full.names = TRUE, no.. = TRUE)

    ## Skip all sub-directories, all files in flat folder.
    files <- files[which(sapply(files, function(x) file.info(x)$isdir) != TRUE)]

    ## Very simply checks (to extend later)
    if (length(files) == 0)
        warning(paste("MCUPGMA build: no files in directory: ",
                      copy_path,
                      " (build failed)"))

    ## Any empty files?
    if (!all(sapply(files, function(x) file.info(x)$size > 0)))
        warning(paste("MCUPGMA build: empty files in directory: ",
                      copy_path,
                      " (build failed)"))

    print(paste("INSTALL FROM:", copy_path, "TO:", dest_mcupgma))

    ## Write all files. (return is logical for each element)
    retCopy <- file.copy(files, dest_mcupgma, overwrite = TRUE)

    if (!all(retCopy)) {
        broken <- files[which(retCopy == FALSE)]
        print("FILES UNABLE TO COPY:")
        print(broken)
        stop(nbErrorMsg("Errors during mcupgma file copies (see list above)"))
    }
}

## @TODO Unused?
## files2 <- Sys.glob(paste0(dest_mcupgma, "/*"))
files <- list.files(path = dest_mcupgma, full.names = TRUE, no.. = TRUE)

## This fix should be in Makevars, but as Gnu make syntax is only allowed on
## Windows, it is hastingly added here for *nix...
## @TODO Remove
## Following pattern may be non portable, so Sys.glob is used like in R Writing
## extensions documentation.
##    list.files(".", pattern = paste(".*\\", SHLIB_EXT, sep=""),
##                    full.names = TRUE)
sapply(Sys.glob(paste0("*", SHLIB_EXT)),
       function(file) {
           if (file != tolower(file)) {
               print(paste("Create:", tolower(file), "from", file))
               file.copy(c(file), c(tolower(file)), overwrite = TRUE)
           }
       })

## Copy own (non-mcugpma) libraries (basically only netboost.so) to dest.
## Basically the code from R manual
dir.create(dest_lib, recursive = TRUE, showWarnings = FALSE)
files <- Sys.glob(paste0("*", SHLIB_EXT))
## Following pattern may be non portable, so Sys.glob is used like in R Writing
## extensions documentation.
## files <- list.files(".", pattern = paste(".*\\", SHLIB_EXT, sep=""),
##                     full.names = TRUE)
file.copy(files, dest_lib, overwrite = TRUE)
print(files)

if (file.exists("symbols.rds"))
    file.copy("symbols.rds", dest_lib, overwrite = TRUE)

#' Execute a program/script from the installed MCUPGMA suite.
#'
#' @param exec    Name of the file of the executable.
#' @param console Logical. Print output to R console or fetch for return to
#'   caller
#' @param ...  Arguments passed to mcupgma executable in order required by
#'   program
#' @return console=TRUE: exit code (0: no error). console=FALSE: STDOUT/STDERR
#'   output
#' @examples
#'   mcupgma_exec(exec="cluster.pl", "--help")
#' @export
mcupgma_exec <- function(exec=NULL, ..., console=TRUE) {
    if (is.null(exec)) stop("mcupgma_exec: call without executable")

    exec_abs_path <- file.path(netboostMCUPGMAPath(), exec)

    if (!file.exists(exec_abs_path))
        stop(paste("mcupgma_exec: file does not exist:", exec, exec_abs_path))

    # Types may become mixed giving many parameters, so ensure boolean.
    console <- isTRUE(as.logical(console))

    # Arguments must be bundled in character vector
    call_args <- as.character(unlist(list(...), use.names=FALSE))
    
    # Default: STDOUT/STDERR to R console
    std <- ""

    # If console is not set, write output to temporary file.
    if (!console) std <- tempfile()

    ret <- system2(command = exec_abs_path,
                   stdout = std, stderr = std,
                   wait=TRUE,
                   args=call_args,
                   env=c(paste0("TMP_PATH=", netboostTmpPath())))

    #  flush.console()

    # If execution returned error, always throw warning.
    # Also, save copy of output.
    if (ret != 0) {
        preserve <- file.path(netboostTmpPath(), paste0("output_", exec))
        file.copy(std, preserve)
        warning(paste("Execution of", exec, "returned no success:", ret,
                      "(this may be an real error or not).",
                      "STDOUT/ERR output saved in:", preserve),
                call. = FALSE)
        #    file.show(std)
    }
    
    # If STDIN/STDERR was printed on console, return exit code.
    # Else, read output from temporary file and return as text.
    if (console) {
        return(ret)
    } else {
        std_output <- readChar(std, file.info(std)$size)
        unlink(std)
        return(std_output)
    }
}

#' Cleans the netboost temporary folder. This can be useful during the session
#' as mcupgma creates vast directory structures (for iterations).
#' Creates the own folder (all netboost temporary data is stored in
#' netboostTmpPath(), which is equal to tempdir()/netboost).
#' Also used for first time setup of folder.
#'
#' @param verbose Flag verbose
#' @return none
netboostTmpCleanup <- function(verbose = FALSE) {
    folder <- netboostTmpPath()

    if (dir.exists(folder)) {
        if (verbose)
            message(paste("Netboost: cleaning temporary folder:", folder))

        ## Delete and recreate more convenient than globbing through the folders
        unlink(folder, recursive = TRUE)
    }

    # Create or recreate folder.
    dir.create(folder)
}

## Note: here also the setup NAMESPACE directives are set (as Roxygen is
## creating the namespace, those are given as Roxygen attributes). The
## importFrom statements are required to instantly load the linked libraries
## Rcpp and RcppParallel, else loading of the own shared lib would fail (the
## imported functions do not matter, but for each package at least one import
## must be present).

## Those are required for CRAN checks but bug out on BiocCheck
#' Package startup: used to fetch installation path of the own package,
#' as required for executing binary programs delivered with it.
#' 
#' @importFrom Rcpp evalCpp
#' @importFrom RcppParallel setThreadOptions
#' @importFrom R.utils gzip isGzipped
#' @importFrom parallel mclapply
#' @importFrom colorspace rainbow_hcl
#' @importFrom grDevices dev.off gray pdf
#' @importFrom graphics abline layout par plot
#' @importFrom stats as.dendrogram as.dist cor cov prcomp hclust order.dendrogram pt
#' @importFrom dynamicTreeCut cutreeDynamic indentSpaces printFlush
#' @importFrom impute impute.knn
#' @importFrom WGCNA allowWGCNAThreads mergeCloseModules plotDendroAndColors
#' @importFrom WGCNA moduleColor.getMEprefix pickSoftThreshold
#' @importFrom utils data packageDescription read.table write.table
#' @importFrom methods is
#'
#' @useDynLib netboost
#'
#' @examples 
#' \dontrun{nb_example()}
#' @return none
#' @param libname Path to R installation (base package dir)
#' @param pkgname Package name (should be "netboost")
.onAttach <- function(libname, pkgname) {
    desc <- packageDescription(pkgname)

    # If no default core count given, detect.  
    if (is.null(getOption("mc.cores")) || !is.integer(getOption("mc.cores"))) {
        # logical = FALSE is not working correctly if CPU has logical cores, which
        # are disabled (at least Linux).
        # Means: if CPU has logical cores, core count should be set manually.
        # cores <- parallel::detectCores() # Bioconductor does not like this
        cores <- NA

        if (is.na(cores)) cores <- 1

        options("mc.cores" = cores)
    }
    
    ## Optional startup message, mainly for development.
    packageStartupMessage(
        paste(pkgname,
              desc$Version,
              "loaded"),
        paste(
            "Default CPU cores:",
            getOption("mc.cores"),
            "\n"),
        appendLF = TRUE
    )
    #                              "Loaded from:", libname),

    # Create temp subfolder in tempdir()
    netboostTmpCleanup()

    ## Add the current (real) loading path to MCUPGMA Makefiles
    ## (install_path.mk is loaded by definitions.mk, which is
    ## included in all real Makefiles).
    mcupgma_install <- file.path(netboostMCUPGMAPath(),
                                 "install_path.mk")

    ## If this file is not existing in this location, this is a non working
    ## installation (may happen during build and included test-loads) (writeLines
    ## throws warning in R CMD check, but we do valid stuff here)
    if (file.exists(mcupgma_install)) {
        # R complains about writeLines (false positive, as not writing to STDOUT).
        # Replaced with write.table to pass package check.
        txt <- c(paste("export INSTALL_PATH := ", netboostMCUPGMAPath()),
                 paste("export TMP_PATH := ", netboostTmpPath()))
        write.table(file = mcupgma_install, as.data.frame(txt),
                    quote = FALSE, row.names = FALSE,
                    col.names = FALSE, append = FALSE, sep="")
        ##    filew <-file(mcupgma_install, open="w")
        ##    writeLines(con=filew, text=c(paste("export INSTALL_PATH := ",
        ##    mcupgmaPath)))
        ##    writeLines(con=filew, text=c(paste("export TMP_PATH := ",
        ##    netboostTmpPath())))
        ##    close(filew)
    }
    # Else successful build would be warned.
    else {
        warning(paste("File not written:", mcupgma_install,
                      "(okay during build, error after installation)"))
    }
}

## #' If package detached, clean up temporary folders.
## #' @return none
## #' @param libpath Library path (unused)
##.onDetach <- function(libpath) {
##    print("kthnxbye")
##}

#' Returns the absolute path to "exec" folder in the package.
#'
#' @return Absolute path of installed package
netboostPackagePath <- function() {
    return(system.file(package="netboost"))
}

#' Returns the absolute path to temporary folder of the package.
#' To change temporary path, use normal R variables (TEMPDIR etc).
#'
#' @return Absolute path for "exec" folder
netboostTmpPath <- function() {
    return(file.path(tempdir(), "netboost"))
}

#' Returns the absolute path to folder with mcupgma executables and scripts.
#'
#' @return Absolute path for "mcupgma" folder
netboostMCUPGMAPath <- function() {
    return(file.path(netboostPackagePath(), "mcupgma"))
}

## Formatting changed by RStudio-Autoformatting (*mostly* compatible to BioC
## preferences)

## Load WGCNA, try to hide the welcome-message (only a try as it is printed...)
## Workaround using environment to force WGCNA skipping it's welcome-message.
Sys.setenv(ALLOW_WGCNA_THREADS = 1)
suppressPackageStartupMessages(require(WGCNA))
Sys.unsetenv("ALLOW_WGCNA_THREADS")

## require(colorspace)
## require(parallel)

#' Netboost clustering.
#'
#' The Netboost clustering is performed in three subsequent steps. First, a
#' filter of important edges in the network is calculated. Next, pairwise
#' distances are calculated. Last, clustering is performed. For details see
#' Schlosser et al. doi...
#'
#' @name netboost
#' @param datan    Data frame were rows correspond to samples and columns to
#'   features.
#' @param stepno    Integer amount of boosting steps applied in the filtering
#'   step
#' @param filter_method    The following filtering methods are supported:
#'   "boosting" (non-zero coefficients in likelihood based boosting),
#'   "skip" (no filter), "kendall" (stats::cor.test),
#'   "spearman" (stats::cor.test), "pearson" (stats::cor.test)
#' @param until    Stop at index/column (if 0: iterate through all columns).
#'   For testing purposes in large datasets.
#' @param progress    Integer. If > 0, print progress after every X steps (
#' Progress might not be reported completely accurate due to parallel execution)
#' @param mode    Integer. Mode (0: x86, 1: FMA, 2: AVX). Features are only
#'   available if compiled accordingly and available on the hardware.
#' @param soft_power    Integer. Exponent of the transformation. Set
#'    automatically based on the scale free topology criterion if unspecified.
#' @param max_singleton    Integer. The maximal singleton in the clustering.
#'   Usually equals the number of features.
#' @param qc_plot    Logical. Should plots be created?
#' @param min_cluster_size  Integer. The minimum number of features in one
#' module.
#' @param ME_diss_thres    Numeric. Module Eigengene Dissimilarity Threshold for
#'   merging close modules.
#' @param cores    Integer. Amount of CPU cores used (<=1 : sequential)
#' @param scale    Logical. Should data be scaled and centered?
#' @param method    A character string specifying the method to be used for
#'   correlation coefficients.
#' @param verbose    Additional diagnostic messages.
#' @param n_pc        Number of principal components and variance explained
#'   entries to be calculated. The number of returned variance explained
#'   entries is currently ‘min(n_pc,10)’. If given ‘n_pc’ is 
#'   greater than 10, a warning is issued.
#' @param robust_PCs	Should PCA be calculated on ranked data (Spearman PCA)?
#'   Rotations will not correspond to original data if this is applied.
#' @param nb_min_varExpl    Minimum proportion of variance explained for
#'   returned module eigengenes. The number of PCs is capped at n_pc.
#' @return dendros    A list of dendrograms. For each fully separate part of the
#'   network an individual dendrogram.
#' @return names    A vector of feature names.
#' @return colors    A vector of numeric color coding in matching order of names
#'   and module eigengene names (color = 3 -> variable in ME3).
#' @return MEs    Aggregated module measures (Module eigengenes).
#' @return var_explained    Proportion of variance explained per module
#'   eigengene
#'   per principal component (max n_pc principal components are listed).
#' @return rotation    Matrix of variable loadings divided by their singular
#'   values. datan %*% rotation = MEs (with datan potentially scaled)
#' @return filter    Filter-Matrix as generated by the nb_filter function.
#'
#' @examples
#' data('tcga_aml_meth_rna_chr18',  package='netboost')
#' results <- netboost(datan=tcga_aml_meth_rna_chr18, stepno=20L,
#'    soft_power=3L, min_cluster_size=10L, n_pc=2, scale=TRUE,
#'    ME_diss_thres=0.25, qc_plot=TRUE)
#'
#' @export
netboost <-
    function(datan = NULL,
             stepno = 20L,
             filter_method = c("boosting","skip",
                "kendall", "spearman", "pearson"),
             until = 0L,
             progress = 1000L,
             mode = 2L,
             soft_power = NULL,
             max_singleton = ncol(datan),
             qc_plot = TRUE,
             min_cluster_size = 2L,
             ME_diss_thres = 0.25,
             n_pc = 1,
             robust_PCs = FALSE,
             nb_min_varExpl = 0.5,
             cores = as.integer(getOption("mc.cores", 2)),
             scale = TRUE,
             method = c("pearson", "kendall", "spearman"),
             verbose = getOption("verbose")) {
        # Initialize parallelization of WGCNA package.
        if (cores > 1)
            WGCNA::allowWGCNAThreads(nThreads = as.integer(cores))

        if (is.null(datan) || !is.data.frame(datan))
            stop("netboost: Error: datan must be a data.frame.")

        if (is.null(stepno) || !is.integer(stepno))
            stop("netboost: Error: stepno must be an integer.")

        if (is.null(min_cluster_size) || !is.integer(min_cluster_size))
            stop("netboost: Error: min_cluster_size must be an integer.")

        if (is.null(ME_diss_thres) || !is.numeric(ME_diss_thres))
            stop("netboost: Error: ME_diss_thres must be numeric.")

        verbose <- as.logical(verbose)

        if (ncol(datan) > 5e+06) {
            stop(
                "A bug in sparse UPGMA currently prevents analyses",
                " with more than 5 million features."
            )
        }

        if (scale) {
            if (verbose) message("Netboost: Scaling and centering data.")
            
            datan <-
                as.data.frame(scale(datan, center = TRUE, scale = TRUE))
        }

        if (verbose) message("Netboost: Initialize filter step.")

        filter <-
            nb_filter(
                datan = datan,
                stepno = stepno,
                until = until,
                filter_method = filter_method,
                progress = progress,
                cores = cores,
                mode = mode,
                verbose = verbose
            )
        
        if (verbose) message("Netboost: Finished filter step.")

        if (is.null(soft_power)) {
            # Random subset out of allocation
            random_features <-
                sample(ncol(datan), min(c(10000, ncol(datan))))
            # Call the network topology analysis function
            sft <- WGCNA::pickSoftThreshold(datan[, random_features])
            soft_power <- sft[["powerEstimate"]]
            if (verbose) {
                message(
                    paste0(
                        "Netboost: soft_power was set to ",
                        soft_power,
                        " based on the scale free topology criterion."
                    )
                )}
        }
        
        if (verbose) message("Netboost: Initialize distance calculation (",
        method[1],").")
        dist <-
            nb_dist(
                datan = datan,
                filter = filter,
                soft_power = soft_power,
                cores = cores,
                method = method[1]
            )

        if (verbose) message("Netboost: Finished distance calculation.")

        if (verbose) message("Netboost: Initialising clustering step.")

        results <-
            nb_clust(
                datan = datan,
                filter = filter,
                dist = dist,
                min_cluster_size = min_cluster_size,
                ME_diss_thres = ME_diss_thres,
                n_pc = n_pc,
                robust_PCs = robust_PCs,
                nb_min_varExpl = nb_min_varExpl,
                max_singleton = max_singleton,
                cores = cores,
                method = method[1],
                qc_plot = qc_plot
            )

        results$filter <- filter
        
        if (verbose) {
            message("Netboost: Finished clustering step.")
            message("Netboost: Finished Netboost.")
        }

        invisible(results)
    }

#' Calculate network adjacencies for filter
#'
#' @name calculate_adjacency
#' @param datan    Data frame were rows correspond to samples and columns to
#'   features.
#' @param filter    Filter-Matrix as generated by the nb_filter function.
#' @param soft_power Integer. Exponent of the transformation. Set automatically
#'   based on the scale free topology criterion if unspecified.
#' @param method    A character string specifying the method to be used for
#'   correlation coefficients.
#' @param cores    Integer. Amount of CPU cores used (<=1 : sequential).
#' @return Vector with adjacencies for the filter
calculate_adjacency <-
    function(datan,
             filter,
             soft_power = 2,
             method = c("pearson", "kendall", "spearman"),
            cores = getOption("mc.cores",2L)) {
        if(method[1] == "spearman"){
            datan <- apply(X=datan,MARGIN=2,FUN=rank)
            return(unlist(parallel::mclapply(X=seq(
                from = 1,
                to = nrow(filter),
                by = 1
            ),
            FUN=function(i) {
                abs(WGCNA::cor(datan[, filter[i, 1]],
                               datan[, filter[i, 2]], method = "pearson")) ^ soft_power
            },mc.cores=cores)))
        } else {
            return(unlist(parallel::mclapply(X=seq(
                from = 1,
                to = nrow(filter),
                by = 1
            ),
            FUN=function(i) {
                abs(WGCNA::cor(datan[, filter[i, 1]],
                               datan[, filter[i, 2]], method = method[1])) ^ soft_power
            },mc.cores=cores)))
        }
             
    }

#' Calculate distance (external wrapper for internal C++ function)
#' Parallelisation inside C++ program with RcppParallel.
#'
#' @name nb_dist
#' @param filter    Filter-Matrix as generated by the nb_filter function.
#' @param datan    Data frame were rows correspond to samples and columns to
#'   features.
#' @param soft_power    Integer. Exponent of the transformation. Set 
#'  automatically based on the scale free topology criterion if unspecified.
#' @param cores    Integer. Amount of CPU cores used (<=1 : sequential).
#' @param verbose    Additional diagnostic messages.
#' @param method    A character string specifying the method to be used for
#'   correlation coefficients.
#' @return Vector with distances.
#'
#' @examples
#'  data('tcga_aml_meth_rna_chr18', package='netboost')
#'  cores <- as.integer(getOption('mc.cores', 2))
#'  datan <- as.data.frame(scale(tcga_aml_meth_rna_chr18, center=TRUE,
#'  scale=TRUE))
#'  filter <- nb_filter(datan=datan, stepno=20L, until=0L, progress=1000L,
#'  cores=cores,mode=2L)
#'  dist <- nb_dist(datan=datan, filter=filter, soft_power=3L, cores=cores)
#'  summary(dist)
#'
#' @export
nb_dist <-
    function(filter,
             datan,
             soft_power = 2,
             cores = getOption("mc.cores", 2L),
             verbose = getOption("verbose"),
             method = c("pearson", "kendall", "spearman")) {
        # if (is.null(filter) || is.null(adjacency)) stop('Both filter and
        # adjacency must be provided')
        if (!(is.matrix(filter) &&
              (nrow(filter) > 0) && (ncol(filter) > 0)))
            stop("filter must be matrix with nrow > 0 and ncol >0")

        # if (!(is.vector(adjacency) && (length(adjacency) > 0)))
        # if (is.null(filter) || is.null(adjacency)) stop('Both filter and
        # adjacency must be provided')
        if (!(is.matrix(filter) &&
              (nrow(filter) > 0) && (ncol(filter) > 0)))
            stop("filter must be matrix with nrow > 0 and ncol >0")
        
        # if (!(is.vector(adjacency) && (length(adjacency) > 0)))
        # stop('adjacency is required a vector with length > 0')
        cores <- max(as.integer(cores), 1)
        
        ## RcppParallel amount of threads to be started
        setThreadOptions(numThreads = cores)
        
        return(cpp_dist_tom(
            filter,
            calculate_adjacency(
                datan = datan,
                filter = filter,
                soft_power = soft_power,
                method = method[1],
                cores=cores)
        ))
    }

#' Calculate dendrogram for a sparse distance matrix
#' (external wrapper MC-UPGMA clustering package Loewenstein et al.
#'
#' @name nb_mcupgma
#' @param filter    Filter-Matrix as generated by the nb_filter function.
#' @param dist    Distance-Matrix as generated by the nb_dist function.
#' @param max_singleton    Integer The maximal singleton in the clustering.
#'                      Usually equals the number of features.
#' @param cores    Integer Amount of CPU cores used (<=1 : sequential)
#' @param verbose    Logical Additional diagnostic messages.
#' @return Raw dendrogram to be processed by tree_search and tree_dendro.
#'
#' @examples
#'    data('tcga_aml_meth_rna_chr18', package='netboost')
#'    cores <- as.integer(getOption('mc.cores', 2))
#'    datan <- as.data.frame(scale(tcga_aml_meth_rna_chr18,
#'    center=TRUE, scale=TRUE))
#'    filter <- nb_filter(datan=datan, stepno=20L, until=0L,
#'                        progress=1000L, cores=cores, mode=2L)
#'    dist <- nb_dist(datan=datan, filter=filter, soft_power=3L, cores=cores)
#'    max_singleton = dim(tcga_aml_meth_rna_chr18)[2]
#'    forest <- nb_mcupgma(filter=filter, dist=dist,
#'                         max_singleton=max_singleton, cores=cores)
#'  head(forest)
#'
#' @export
nb_mcupgma <-
    function(filter,
             dist,
             max_singleton,
             cores = getOption("mc.cores", 2L),
             verbose = getOption("verbose")) {
        # Deletes all files under netboostTmpPath(), esp. clustering/iteration
        netboostTmpCleanup()
        
        if (max_singleton > 5e+06) {
            stop("A bug in sparse UPGMA currently prevents analyses",
                 " with more than 5 million features.")
        } else if (max_singleton < 3e+04) {
        tmp_dist <- rep(1,max_singleton*(max_singleton-1)/2)
        for(i in 1:nrow(filter)){
                tmp_dist[max_singleton*(filter[i,1]-1) - filter[i,1]*(filter[i,1]-1)/2 + filter[i,2]-filter[i,1]] <- dist[i]
        }
        class(tmp_dist) <- "dist"
        attr(tmp_dist, 'Size') <- max_singleton

        tmp <- stats::hclust(d=tmp_dist,method="average")
        index1 <- tmp$merge[,1]>0
        index2 <- tmp$merge[,2]>0
        tmp2 <- tmp$merge
        tmp2[index1,1] <- tmp2[index1,1] + max_singleton
        tmp2[index2,2] <- tmp2[index2,2] + max_singleton
        tmp2[!index1,1] <- -tmp2[!index1,1]
        tmp2[!index2,2] <- -tmp2[!index2,2]
        tmp2 <- cbind(tmp2,tmp$height,(max_singleton+1):(max_singleton+nrow(tmp2)))
        colnames(tmp2) <- c("cluster_id1","cluster_id2", "distance", "cluster_id3")
        return(as.matrix(tmp2))
        } else {       
        if (!dir.create(file.path(netboostTmpPath(), "clustering")))
            stop("Unable to create: ",
                 file.path(netboostTmpPath(), "clustering"))
        
        file_dist_edges <-
            file.path(netboostTmpPath(), "clustering", "dist.edges")
        file_dist_tree <-
            file.path(netboostTmpPath(), "clustering", "dist.mcupgma_tree")
        
        # write.table(file='clustering/dist.edges',
        write.table(
            file = file_dist_edges,
            cbind(
                format(filter, scientific = FALSE,
                       trim = TRUE),
                format(dist, scientific = FALSE, trim = TRUE)
            ),
            row.names = FALSE,
            col.names = FALSE,
            sep = "\t",
            quote = FALSE
        )
        
        # Compress edges file (inplace)
        file_dist_edges_gz <- paste(file_dist_edges, ".gz", sep="")
        ret <- R.utils::gzip(file_dist_edges, destname = file_dist_edges_gz,
                             overwrite = TRUE)
        
        if (attr(ret, "nbrOfBytes") <= 0 || !R.utils::isGzipped(file_dist_edges_gz))
            warning(paste("Gzip maybe failed on:", file_dist_edges,
                          "Return:", as.character(ret),
                          " Bytes: ", attr(ret, "nbrOfBytes")))
        
        ret <-
            mcupgma_exec(
                exec = "cluster.pl",
                "-max_distance",
                1,
                "-max_singleton",
                max_singleton,
                "-iterations 1000 -heap_size 10000000 -num_hash_buckets 40",
                "-jobs",
                cores,
                "-retries 1",
                "-output_tree_file",
                file_dist_tree,
                "-split_unmodified_edges",
                max(cores,2L),
                file_dist_edges_gz,
                console = FALSE
            )
        
        if (verbose>1)
            message(ret)
        
        if (!file.exists(file_dist_tree) ||
            file.info(file_dist_tree)[["size"]] == 0)
            stop("No output file created. mcupgma error.")
        
        return(as.matrix(
            read.table(
                file = file_dist_tree,
                row.names = NULL,
                col.names = c("cluster_id1",
                              "cluster_id2", "distance", "cluster_id3")
            )
        ))
        }
    }

#' Extracts independent trees from nb_mcupgma results (external wrapper for
#' internal C++ function)
#'
#' @name tree_search
#' @param forest    Raw dendrogram-matrix as generated by the nb_mcupgma
#'   function.
#' @return List
#'   
#' @examples
#'    data('tcga_aml_meth_rna_chr18',  package='netboost')
#'    cores <- as.integer(getOption('mc.cores', 2))
#'    datan <- as.data.frame(scale(tcga_aml_meth_rna_chr18, center=TRUE,
#'                                 scale=TRUE))
#'    filter <- nb_filter(datan=datan, stepno=20L, until=0L, progress=1000L,
#'                        cores=cores,mode=2L)
#'    dist <- nb_dist(datan=datan, filter=filter, soft_power=3L, cores=cores)
#'    max_singleton = dim(tcga_aml_meth_rna_chr18)[2]
#'    forest <- nb_mcupgma(filter=filter, dist=dist,
#'                         max_singleton=max_singleton, cores=cores)
#'    trees <- tree_search(forest)
#'    str(trees[[length(trees)]])
#'
#' @export
tree_search <- function(forest = NULL) {
    if (is.null(forest) || !is.matrix(forest))
        stop("forest must be provided (as matrix)")
    
    return(cpp_tree_search(forest))
}


#' Calculate the dendrogram for an individual tree
#'
#' @name tree_dendro
#' @param tree    A list with two elements. ids, which is an integer vector of
#'   feature identifiers and rows, which is an integer vector of selected rows
#'   in the corresponding forest
#' @param datan    Data frame were rows correspond to samples and columns to
#'   features.
#' @param forest    Raw dendrogram-matrix as generated by the nb_mcupgma 
#'   function.
#' @return List of tree specific objects including dendrogram, tree data and
#'   features.
tree_dendro <- function(tree,
                        datan,
                        forest) {
    index.features <- tree[["ids"]][tree[["ids"]] <= dim(datan)[2]]
    data_tree <- datan[, index.features]
    
    colnames_tree <- colnames(datan)[index.features]
    tree_cluster <- forest[tree[["rows"]], , drop = FALSE]
    
    all_ids <- rev(sort(unique(c(forest[, c(1, 2, 4)]))))
    none_tree_ids <- all_ids[!(all_ids %in% tree[["ids"]])]
    for (i in none_tree_ids) {
        for (j in c(1, 2, 4)) {
            tree_cluster[tree_cluster[, j] > i, j] <-
                tree_cluster[tree_cluster[,
                                          j] > i, j] - 1
        }
    }
    
    feature_names <- colnames(data_tree)
    
    cutpoint <- dim(data_tree)[2]
    dendro <- list()
    dendro[["merge"]] <- tree_cluster[, c(1, 2), drop = FALSE]
    dendro[["merge"]][dendro[["merge"]] <= cutpoint] <-
        -dendro[["merge"]][dendro[["merge"]] <= cutpoint]
    dendro[["merge"]][dendro[["merge"]] > 0] <-
        dendro[["merge"]][dendro[["merge"]] > 0] - cutpoint
    dendro[["merge"]] <- apply(dendro[["merge"]], c(1, 2), function(x) {
        (as.integer(x))
    })
    dendro[["height"]] <- tree_cluster[, 3]
    dendro[["order"]] <- seq(from = 1, to = cutpoint, by = 1)
    dendro[["labels"]] <- colnames_tree
    class(dendro) <- "hclust"
    b <- as.dendrogram(dendro)
    b.order <- order.dendrogram(b)
    dendro[["order"]] <- b.order
    
    return(list(
        dendro = dendro,
        data = data_tree,
        names = feature_names
    ))
}

#' Module detection for an individual tree
#'
#' @name cut_dendro
#' @param tree_dendro    List of tree specific objects including dendrogram, 
#'   tree
#'   data and features originating from the tree_dendro function.
#' @param min_cluster_size    Integer. The minimum number of features in one 
#'   module.
#' @param datan    Data frame were rows correspond to samples and columns to
#'   features.
#' @param ME_diss_thres    Numeric. Module Eigengene Dissimilarity Threshold for
#'   merging close modules.
#' @param name_of_tree    String. Annotating plots and messages.
#' @param qc_plot    Logical. Should plots be created?
#' @param n_pc    Number of principal components and variance explained
#'   entries to be calculated. The number of returned variance explained entries
#'   is currently ‘min(n_pc,10)’. If given ‘n_pc’ is greater than 10, a warning 
#'   is issued.
#' @param robust_PCs	Should PCA be calculated on ranked data (Spearman PCA)?
#'   Rotations will not correspond to original data if this is applied.
#' @param nb_min_varExpl    Minimum proportion of variance explained for
#'   returned module eigengenes. The number of PCs is capped at n_pc.
#' @param method    A character string specifying the method to be used for
#'   correlation coefficients.
#' @return List
cut_dendro <-
    function(tree_dendro,
             min_cluster_size = 2L,
             datan,
             ME_diss_thres,
             name_of_tree = "",
             qc_plot = TRUE,
             n_pc = 1,
             robust_PCs = FALSE,
             nb_min_varExpl = 0.5,
             method = c("pearson", "kendall", "spearman")) {
        dynamicMods <-
            dynamicTreeCut::cutreeDynamic(
                dendro = tree_dendro[["dendro"]],
                method = "tree",
                deepSplit = TRUE,
                minClusterSize = min_cluster_size
            )
        ### Merging of Dynamic Modules ### Calculate eigengenes
        MEList <-
            netboost::nb_moduleEigengenes(
                expr = tree_dendro[["data"]],
                colors = dynamicMods,
                n_pc = n_pc,
                robust = robust_PCs,
                nb_min_varExpl = nb_min_varExpl
            )
        MEs <- MEList[["nb_eigengenes"]]
        # Calculate dissimilarity of module eigengenes
        MEDiss <- 1 - abs(WGCNA::cor(MEs,method = method[1]))
        # Cluster module eigengenes
        if (length(MEDiss) > 1) {
            METree <- hclust(as.dist(MEDiss), method = "average")
            if (qc_plot == TRUE) {
                graphics::plot(
                    METree,
                    main = paste0(name_of_tree,
                                  "Clustering of module eigengenes"),
                    xlab = "",
                    sub = ""
                )
                graphics::abline(h = ME_diss_thres, col = "red")
            }
            
            
            save_verbose <- getOption("verbose")
            options("verbose" = FALSE)

#             colors_old <- dynamicMods
#             colors_new <- c()
#             while(length(unique(colors_old))>length(unique(colors_new))){
#             	if(length(colors_new)>0){
#             	colors_old <- colors_new            	
#             	}
#         		MEcor <- abs(WGCNA::cor(netboost::nb_moduleEigengenes(
#                 	expr = tree_dendro[["data"]],
#                 	colors = colors_old,
#                 	n_pc = 1,
#                 	robust = robust_PCs)[["nb_eigengenes"]],method = method))
#                 MEcor <- MEcor[rownames(MEcor)!="ME0_pc1",colnames(MEcor)!="ME0_pc1"]
#                 colors_match <- gsub(pattern="_pc1",replacement="",x=gsub(pattern="ME",replacement="",x=colnames(MEcor)))
#                 MEcor <- MEcor - diag(ncol(MEcor))
#                 colors_match <- cbind(colors_match[which(MEcor>ME_diss_thres,arr.ind=TRUE)[,"row"]],colors_match[which(MEcor>ME_diss_thres,arr.ind=TRUE)[,"col"]])
#                 colors_match <- colors_match[colors_match[,2] < colors_match[,1],,drop=FALSE]
#                 colors_new <- colors_old
#                 if(nrow(colors_match)>0){
#                     for(i in 1:nrow(colors_match)){
#                         colors_new[colors_new==colors_match[i,1]] <- colors_match[i,2]
#                     }
#                 }
#             }
#             mergedColors <- colors_new
#  

            colors_old <- dynamicMods
            colors_new <- c()
            while(length(unique(colors_old))>length(unique(colors_new))){
            	if(length(colors_new)>0){
            		colors_old <- colors_new            	
            	}
        		MEs <- netboost::nb_moduleEigengenes(
                	expr = tree_dendro[["data"]],
                	colors = colors_old,
                	n_pc = 1,
                	robust = robust_PCs)[["nb_eigengenes"]]
				colors_new <- colors_old            	
        		MEDiss <- 1 - abs(WGCNA::cor(MEs,method = method[1]))
       			if (length(MEDiss) > 1) {
            		METree <- hclust(as.dist(MEDiss), method = "average")
            		clust <- WGCNA::cutreeStatic(METree, cutHeight = ME_diss_thres, minSize = 2)
            		for(i in clust[clust!=0]){
            			colors_match <- METree$labels[clust==i]
            			colors_match <- colors_match[colors_match!="ME0_pc1"]
            			if(length(colors_match)>1){
							colors_match <- gsub(pattern="_pc1",replacement="",x=gsub(pattern="ME",replacement="",x=colors_match))
							colors_new[colors_new%in%colors_match] <- as.character(min(as.integer(colors_match)))	
            			}
        			}
				}
			}
            mergedColors <- colors_new

            
#             merged <-
#                 WGCNA::mergeCloseModules(
#                     exprData = tree_dendro[["data"]],
#                     dynamicMods,
#                     cutHeight = ME_diss_thres,
#                     corOptions = list(method = method, use = "p"),
#                     verbose = 3
#                 )
#             mergedColors <- merged[["colors"]]
            # Calculate eigengenes

           options("verbose" = save_verbose)
            MEList <-
                netboost::nb_moduleEigengenes(
                    expr = tree_dendro[["data"]],
                    colors = mergedColors,
                    n_pc = n_pc,
                    robust = robust_PCs,
                    nb_min_varExpl = nb_min_varExpl
                )
            MEs <- MEList[["nb_eigengenes"]]
            MEDiss <- 1 - abs(WGCNA::cor(MEs,method = method[1]))
            if (length(MEDiss) > 1) {
                METree <- hclust(as.dist(MEDiss), method = "average")
                if (qc_plot == TRUE &
                    length(tree_dendro[["dendro"]][["labels"]]) > 2) {
                    graphics::plot(
                        METree,
                        main = paste0(
                            name_of_tree,
                            "Clustering of merged module eigengenes"
                        ),
                        xlab = "",
                        sub = ""
                    )
                    WGCNA::plotDendroAndColors(
                        dendro = tree_dendro[["dendro"]],
                        colors = mergedColors,
                        "Merged Dynamic",
                        dendroLabels = FALSE,
                        hang = 0.01,
                        addGuide = TRUE,
                        guideHang = 0.05,
                        main = paste0(name_of_tree, "Cluster Dendrogram")
                    )
                }
            }
        } else {
            message("\nOnly one module in ", name_of_tree, ".\n")
            mergedColors <- dynamicMods
            if (length(tree_dendro[["dendro"]][["labels"]]) > 2) {
                if (qc_plot == TRUE) {
                    graphics::plot(
                        tree_dendro[["dendro"]],
                        main = paste0(
                            name_of_tree,
                            "Cluster Dendrogram ",
                            "(Tree maximaly consists out of one module.)"
                        )
                    )
                }
            } else {
                message(
                    "\nOnly two elements in the one module in ",
                    name_of_tree,
                    " (no plot generated).\n"
                )
            }
        }
        message(
            "\nNetboost extracted ",
            length(table(mergedColors)),
            " modules (including background) with an average size of ",
            mean(table(mergedColors)[-1]),
            " (excluding background) from ",
            substr(name_of_tree,
                   start = 1, stop = (nchar(name_of_tree) - 1)),
            ".\n"
        )
        return(
            list(
                colors = mergedColors,
                MEs = MEs,
                var_explained = MEList[["var_explained"]],
                rotation = MEList[["rotation"]]
            )
        )
        # svd_PCs = MEList[["eigengenes"]],
    }

#' Module detection for the results from a nb_mcupgma call
#'
#' @name cut_trees
#' @param trees    List of trees, where one tree is a list of ids and rows
#' @param datan    Data frame were rows correspond to samples and columns to
#'   features.
#' @param forest    Raw dendrogram-matrix as generated by the nb_mcupgma 
#'   function.
#' @param min_cluster_size    Integer. The minimum number of features in one
#'   module.
#' @param ME_diss_thres    Numeric. Module Eigengene Dissimilarity Threshold for
#'   merging close modules.
#' @param qc_plot    Logical. Should plots be created?
#' @param n_pc    Number of principal components and variance explained
#'   entries to be calculated. The number of returned variance explained entries
#'   is currently ‘min(n_pc,10)’. If given ‘n_pc’ is greater than 10, a warning 
#'   is issued.
#' @param robust_PCs	Should PCA be calculated on ranked data (Spearman PCA)?
#'   Rotations will not correspond to original data if this is applied.
#' @param nb_min_varExpl    Minimum proportion of variance explained for
#'   returned module eigengenes. The number of PCs is capped at n_pc.
#' @param method    A character string specifying the method to be used for
#'   correlation coefficients.
#' @return List
#'
#' @examples
#' data('tcga_aml_meth_rna_chr18',  package='netboost')
#'  cores <- as.integer(getOption('mc.cores', 2))
#'  datan <- as.data.frame(scale(tcga_aml_meth_rna_chr18, center=TRUE,
#'  scale=TRUE))
#'  filter <- nb_filter(datan=datan, stepno=20L, until=0L, progress=1000L,
#'  cores=cores,mode=2L)
#'  dist <- nb_dist(datan=datan, filter=filter, soft_power=3L, cores=cores)
#'  max_singleton = dim(tcga_aml_meth_rna_chr18)[2]
#'  forest <- nb_mcupgma(filter=filter, dist=dist, max_singleton=max_singleton,
#'  cores=cores)
#'  trees <- tree_search(forest)
#'  results <- cut_trees(trees=trees,datan=datan, forest=forest,
#'  min_cluster_size=10L, ME_diss_thres=0.25, qc_plot=TRUE)
#'
#' @export
cut_trees <-
    function(trees,
             datan,
             forest,
             min_cluster_size = 2L,
             ME_diss_thres,
             qc_plot = TRUE,
             n_pc = 1,
             robust_PCs = FALSE,
             nb_min_varExpl = 0.5,
             method = c("pearson", "kendall", "spearman")) {
        res <- list()
        i <- 1L
        
        for (tree in trees) {
            tree_dendro_res <-
                tree_dendro(tree = tree,
                            datan = datan,
                            forest = forest)
            res[[i]] <- list()
            res[[i]][["dendro"]] <- tree_dendro_res[["dendro"]]
            res[[i]][["data"]] <- tree_dendro_res[["data"]]
            res[[i]][["names"]] <- tree_dendro_res[["names"]]
            cut_dendro_res <-
                cut_dendro(
                    tree_dendro = tree_dendro_res,
                    min_cluster_size = min_cluster_size,
                    datan = datan,
                    ME_diss_thres = ME_diss_thres,
                    name_of_tree = paste0("Tree ",
                                          i, ":"),
                    qc_plot = qc_plot,
                    n_pc = n_pc,
                    robust_PCs = robust_PCs,
                    nb_min_varExpl = nb_min_varExpl,
                    method = method[1]
                )
            res[[i]][["colors"]] <- cut_dendro_res[["colors"]]
            res[[i]][["MEs"]] <- cut_dendro_res[["MEs"]]
            # res[[i]][['svd_PCs']] <- cut_dendro_res[["svd_PCs"]]
            res[[i]][["var_explained"]] <-
                cut_dendro_res[["var_explained"]]
            res[[i]][["rotation"]] <- cut_dendro_res[["rotation"]]
            i <- i + 1
        }
        
        return(res)
    }

#' Netboost clustering step
#'
#' @name nb_clust
#' @param filter    Filter-Matrix as generated by the nb_filter function.
#' @param dist    Distance-Matrix as generated by the nb_dist function.
#' @param datan    Data frame were rows correspond to samples and columns to
#'   features.
#' @param max_singleton    Integer. The maximal singleton in the clustering.
#'   Usually equals the number of features.
#' @param min_cluster_size    Integer. The minimum number of features in one 
#'   module.
#' @param ME_diss_thres    Numeric. Module Eigengene Dissimilarity Threshold for
#'   merging close modules.
#' @param cores    Integer. Amount of CPU cores used (<=1 : sequential)
#' @param qc_plot Logical. Create plot.
#' @param n_pc    Number of principal components and variance explained
#'   entries to be calculated. The number of returned variance explained entries
#'   is currently ‘min(n_pc,10)’. If given ‘n_pc’ is greater than 10, a warning 
#'   is issued.
#' @param robust_PCs	Should PCA be calculated on ranked data (Spearman PCA)?
#'   Rotations will not correspond to original data if this is applied.
#' @param nb_min_varExpl    Minimum proportion of variance explained for
#'   returned module eigengenes. The number of PCs is capped at n_pc.
#' @param method    A character string specifying the method to be used for
#'   correlation coefficients.
#' @return List
#'
#' @examples
#'  data('tcga_aml_meth_rna_chr18',  package='netboost')
#'  cores <- as.integer(getOption('mc.cores', 2))
#'  datan <- as.data.frame(scale(tcga_aml_meth_rna_chr18, center=TRUE, 
#'  scale=TRUE))
#'  filter <- nb_filter(datan=datan, stepno=20L, until=0L, progress=1000L,
#'  cores=cores,mode=2L)
#'  dist <- nb_dist(datan=datan, filter=filter, soft_power=3L, cores=cores)
#'  max_singleton = dim(tcga_aml_meth_rna_chr18)[2]
#'  pdf("test.pdf",width=30)
#'  sum_res <- nb_clust(filter=filter, dist=dist, datan=datan,
#'  max_singleton=max_singleton, min_cluster_size=10L, ME_diss_thres=0.25,
#'  cores=cores, qc_plot=TRUE, n_pc=2L, nb_min_varExpl=0.5)
#'  dev.off()
#' @export
nb_clust <-
    function(filter,
             dist,
             datan,
             max_singleton = dim(datan)[2],
             min_cluster_size = 2L,
             ME_diss_thres = 0.25,
             cores = getOption("mc.cores", 2L),
             qc_plot = TRUE,
             n_pc = 1,
             robust_PCs = FALSE,
             nb_min_varExpl = 0.5,
             method = c("pearson", "kendall", "spearman")) {
        forest <-
            nb_mcupgma(
                filter = filter,
                dist = dist,
                max_singleton = max_singleton,
                cores = cores
            )
        trees <- tree_search(forest)
        results <-
            cut_trees(
                trees = trees,
                datan = datan,
                forest = forest,
                min_cluster_size = min_cluster_size,
                ME_diss_thres = ME_diss_thres,
                qc_plot = qc_plot,
                n_pc = n_pc,
                robust_PCs = robust_PCs,
                nb_min_varExpl = nb_min_varExpl,
                method = method[1]
            )
#         sum_res <- nb_summary(clust_res = results, qc_plot = qc_plot)
        sum_res <- nb_summary(clust_res = results)
        
        return(sum_res)
    }

#' Summarize results from a forest. Plot trees together.
#'
#' @name nb_summary
#' @param clust_res    Clustering results from cut_trees call.
#' @return List
#'
#' @examples
#' data('tcga_aml_meth_rna_chr18',  package='netboost')
#'  cores <- as.integer(getOption('mc.cores', 2))
#'  datan <- as.data.frame(scale(tcga_aml_meth_rna_chr18, center=TRUE,
#'  scale=TRUE))
#'  filter <- nb_filter(datan=datan, stepno=20L, until=0L, progress=1000L,
#'  cores=cores,mode=2L)
#'  dist <- nb_dist(datan=datan, filter=filter, soft_power=3L, cores=cores)
#'  max_singleton = dim(tcga_aml_meth_rna_chr18)[2]
#'  forest <- nb_mcupgma(filter=filter,dist=dist,max_singleton=max_singleton,
#'  cores=cores)
#'  trees <- tree_search(forest)
#'  results <- cut_trees(trees=trees,datan=datan, forest=forest,
#'  min_cluster_size=10L, ME_diss_thres=0.25, qc_plot=FALSE)
#'  sum_res <- nb_summary(clust_res=results)
#'
#' @export
nb_summary <- function(#qc_plot = TRUE,
    clust_res) {
    res <- vector("list")
    # res$clust_res <- clust_res
    n_MEs <- 0
    n_MEs_background <- 0
    for (tree in seq(from = 1,
                     to = length(clust_res),
                     by = 1)) {
        res[["dendros"]][[tree]] <- clust_res[[tree]][["dendro"]]
        res[["names"]] <- c(res[["names"]], clust_res[[tree]][["names"]])
        tmp.col <- clust_res[[tree]][["colors"]]
        tmp.col.new <- tmp.col
        tmp_MEs <- clust_res[[tree]][["MEs"]]
        tmp_MEs_new <- tmp_MEs
        tmp_rotation <- clust_res[[tree]][["rotation"]]
        tmp_rotation <-
            do.call("cbind", lapply(
                tmp_rotation,
                FUN = function(x) {
                    y <-
                        matrix(0,
                               nrow = length(clust_res[[tree]][["names"]]),
                               ncol = ncol(x))
                    rownames(y) <- clust_res[[tree]][["names"]]
                    y[rownames(x),] <- x
                    colnames(y) <- colnames(x)
                    return(y)
                }
            ))
        tmp_rotation_new <- tmp_rotation
        for (col in unique(tmp.col)) {
            if (col != 0 | length(unique(tmp.col)) == 1) {
                n_MEs <- n_MEs + 1
                tmp.col.new[tmp.col == col] <- n_MEs
                colnames(tmp_MEs_new)[grepl(pattern = paste0("ME", col, "_"),
                                            colnames(tmp_MEs))] <-
                    gsub(
                        pattern = paste0("ME",
                                         col, "_"),
                        replacement = paste0("ME", (n_MEs), "_"),
                        colnames(tmp_MEs_new)[grepl(pattern = paste0("ME",
                                                                     col, "_"),
                                                    colnames(tmp_MEs))]
                    )
                colnames(tmp_rotation_new)[grepl(pattern = paste0("ME", col,
                                                                  "_"),
                                                 colnames(tmp_rotation))] <-
                    gsub(
                        pattern = paste0("ME", col,
                                         "_"),
                        replacement = paste0("ME", (n_MEs), "_"),
                        colnames(tmp_rotation_new)[grepl(pattern =
                                                paste0("ME", col, "_"),
                                                colnames(tmp_rotation))]
                    )
            }
            if (col == 0 & length(unique(tmp.col)) != 1) {
                n_MEs_background <- n_MEs_background + 1
                tmp.col.new[tmp.col == col] <- -n_MEs_background
                colnames(tmp_MEs_new)[grepl(pattern = "ME0_",
                                            colnames(tmp_MEs))] <-
                    gsub(
                        pattern = "ME0_",
                        replacement = paste0("ME0_", n_MEs_background, "_"),
                        colnames(tmp_MEs_new)[grepl(pattern = "ME0_",
                                                    colnames(tmp_MEs))]
                    )
                colnames(tmp_rotation_new)[grepl(pattern = "ME0_",
                                                 colnames(tmp_rotation))] <-
                    gsub(
                        pattern = "ME0_",
                        replacement = paste0("ME0_", n_MEs_background, "_"),
                        colnames(tmp_rotation_new)[grepl(pattern = "ME0_",
                                                     colnames(tmp_rotation))]
                    )
            }
        }
        res[["colors"]] <- c(res[["colors"]], tmp.col.new)
        if ("MEs" %in% names(res)) {
            res[["MEs"]] <- cbind(res[["MEs"]], tmp_MEs_new)
        } else {
            res[["MEs"]] <- tmp_MEs_new
        }
        if ("rotation" %in% names(res)) {
            res[["rotation"]] <- c(res[["rotation"]], list(tmp_rotation_new))
        } else {
            res[["rotation"]] <- list(tmp_rotation_new)
        }
        ## if('svd_PCs' %in% names(res)){res$svd_PCs <- cbind(res$svd_PCs,
        ## clust_res[[tree]]$svd_PCs)}else{res$svd_PCs <-
        ## clust_res[[tree]]$svd_PCs}
        if ("var_explained" %in% names(res)) {
            res[["var_explained"]] <-
                cbind(res[["var_explained"]],
                clust_res[[tree]][["var_explained"]])
        } else {
            res[["var_explained"]] <- clust_res[[tree]][["var_explained"]]
        }
    }
    rownames(res[["var_explained"]]) <-
        paste0("PC", seq(
            from = 1,
            to = nrow(res[["var_explained"]]),
            by = 1
        ))
    colnames(res[["var_explained"]]) <-
        unique(unlist(lapply(
            strsplit(split = "_pc",
                     colnames(res[["MEs"]])),
            FUN = function(x) {
                x[1]
            }
        )))
    
    res[["rotation"]] <-
        do.call("cbind", lapply(
            res[["rotation"]],
            FUN = function(x) {
                y <- matrix(0, nrow = length(res[["names"]]), ncol = ncol(x))
                rownames(y) <- res[["names"]]
                y[rownames(x),] <- x
                colnames(y) <- colnames(x)
                return(y)
            }
        ))
    
    message(
        "\nNetboost detected ",
        n_MEs,
        " modules and ",
        n_MEs_background,
        " background modules in ",
        length(clust_res),
        " trees resulting in ",
        ncol(res[["MEs"]]),
        " aggregate measures.\n"
    )
    message("Average size of the modules was ",
        mean(table(res[["colors"]][!(res[["colors"]] <= 0)])), ".\n")
    message(
        sum(res[["colors"]] <= 0),
        " of ",
        length(res[["colors"]]),
        " features (",
        (sum(res[["colors"]] <=
                 0) * 100 /
             length(res[["colors"]])),
        "%) were not assigned to modules.\n"
    )
    
#     if (qc_plot == TRUE) {
#         nb_plot_dendro(nb_summary = res, labels = FALSE)
#     }
    return(res)
}

#' Transfer of Netboost clustering to new data.
#'
#' @name nb_transfer
#' @param nb_summary    Netboost results as generated by the nb_summary 
#'   function.
#' @param new_data    Data frame were rows correspond to samples and columns to
#'   features.
#' @param scale    Logical. Should data be scaled and centered?
#' @param only_module_membership    Logical. Should only module memberships be
#'   transfered and PCs be newly computed?
#' @param robust_PCs	Should PCA be calculated on ranked data (Spearman PCA)?
#'   Rotations will not correspond to original data if this is applied.
#' @return List
#'
#' @examples
#' data('tcga_aml_meth_rna_chr18',  package='netboost')
#' results <- netboost(datan = tcga_aml_meth_rna_chr18, stepno = 20L,
#'     soft_power = 3L, min_cluster_size = 10L, n_pc = 2, scale=TRUE,
#'     ME_diss_thres = 0.25, qc_plot=FALSE)
#' ME_transfer <- nb_transfer(nb_summary = results,
#'     new_data = tcga_aml_meth_rna_chr18,
#'     scale = TRUE)
#' all(round(results[["MEs"]], 12) == round(ME_transfer, 12))
#'
#' @export
nb_transfer <-
    function(nb_summary = NULL,
             new_data = NULL,
             scale = FALSE,
             robust_PCs = FALSE,
             only_module_membership = FALSE) {
        if (!exists("new_data"))
            stop("datan must be provided")
        
        if (!(is.data.frame(new_data) &&
              (nrow(new_data) > 0) && (ncol(new_data) >
                                       0)))
            stop("new_data must be a data frame with dim() > (0,0).")
        
        if (length(nb_summary[["colors"]]) != ncol(new_data)) {
            stop("The number of features in new_data must ",
                       "correspond to the number in nb_summary.")
        }
        
        if (!identical(sort(nb_summary[["names"]]), sort(colnames(new_data)))) {
            stop("The features in new_data (colnames) must ", 
                       "correspond to the features in nb_summary ",
                       "(nb_summary$names).")
        }
        
        new_data <- new_data[, nb_summary[["names"]]]
        
        
        if (robust_PCs) {
        	new_data <- as.data.frame(apply(X=new_data,MARGIN=2,FUN=rank))
            new_data <-
                as.data.frame(scale(new_data, center = TRUE, scale = TRUE))
        } else if (scale) {
            new_data <-
                as.data.frame(scale(new_data, center = TRUE, scale = TRUE))
        }
        
        if (!only_module_membership) {
            MEs <- as.matrix(new_data) %*% nb_summary[["rotation"]]
        } else {
            MEs <- netboost::nb_moduleEigengenes(expr = new_data,robust = robust_PCs,
                                                 colors = nb_summary[["colors"]])[["nb_eigengenes"]]
            colnames(MEs)[lapply(strsplit(x = colnames(MEs), split = "-"), FUN = length) > 1] <-
                paste0("ME0_", substring(text = colnames(MEs)[lapply(strsplit(x = colnames(MEs),
                                                                              split = "-"), FUN = length) > 1], first = 4))
        }
        
        MEs <- MEs[, colnames(nb_summary[["MEs"]])]
        rownames(MEs) <- rownames(new_data)
        return(MEs)
    }


#' Boosting via C++ function. Parallelisation by R-package parallel with forking
#' (overhead of this method does not fall into account as single steps are
#' ~10s).
#'
#' Parallelisation via multicore (via 'parallel'-package). So *nix only atm.
#'
#' @name nb_filter
#' @param datan    Data frame were rows correspond to samples and columns to
#'   features.
#' @param stepno    Integer amount of boosting steps
#' @param until    Stop at index/column (if 0: iterate through all columns)
#' @param progress    Integer. If > 0, print progress after every X steps (mind:
#'   parallel!)
#' @param filter_method    The following filtering methods are supported:
#'   "boosting" (non-zero coefficients in likelihood based boosting),
#'   "skip" (no filter), "kendall" (stats::cor.test),
#'   "spearman" (stats::cor.test), "pearson" (stats::cor.test)
#' @param cores    Integer. Amount of CPU cores used (<=1 : sequential)
#' @param mode    Integer. Mode (0: x86, 1: FMA, 2: AVX). Features are only
#'   available if compiled accordingly and available on the hardware.
#' @param verbose    Additional diagnostic messages.
#' @return matrix n times 2 matrix with the indicies of the n unique entrees of
#'   the filter
#'
#'
#' @examples
#' data('tcga_aml_meth_rna_chr18',  package='netboost')
#'  cores <- as.integer(getOption('mc.cores', 2))
#'  datan <- as.data.frame(scale(tcga_aml_meth_rna_chr18, center=TRUE,
#'  scale=TRUE))
#'  filter <- nb_filter(datan=datan, stepno=20L, until=0L, progress=1000L,
#'  cores=cores,mode=2L)
#'  head(filter)
#'  nrow(filter)/(ncol(datan)*(ncol(datan)-1)/2) # proportion of potential undirected edges
#'
#' @export
nb_filter <-
    function(datan,
             stepno = 20L,
             until = 0L,
             progress = 1000L,
             filter_method = c("spearman","skip",
                 "kendall", "boosting", "pearson"),
             cores = getOption("mc.cores",
                               2L),
             mode = 2L,
             verbose = getOption("verbose")) {
        if (!exists("datan"))
            stop("datan must be provided")
        
        if (!(is.data.frame(datan) &&
              (nrow(datan) > 0) && (ncol(datan) > 0)))
            stop("datan must be a data frame with dim() > (0,0).")
        
        if (!(is.integer(stepno) && (stepno > 0)))
            stop("stepno must be an integer > 0.")
        
        if (!(is.integer(until) && (until >= 0)))
            stop("until must be an integer >= 0.")
        
        if (until == 0)
            until <- ncol(datan)
        
        # check mode
        if (!(mode %in% c(0, 1, 2))) {
            stop("mode must be 0 (x86), 1 (FMA) or 2 (AVX).")
        }
        
        if (ncol(datan) > 5e+06) {
            stop("A bug in sparse UPGMA currently prevents analyses ",
                       "with more than 5 million features.")
        }
        
        if(filter_method[1] == "boosting"){
            if (verbose) message(paste("Netboost: Filtering (boosting)"))
                ## Initialize data structures for optimized boosting (once)
        cpp_filter_base(as.matrix(datan), stepno, mode_ = mode)
        
        ## Parallelization 'conventional' via mclapply.
        if (cores > 1) {
            # print(paste('Parallel version:', cores, 'cores'))
            
            boosting_filter <- mclapply(seq(1, until), function(x) {
                if ((((x - 1) %% progress) == 0)) {
                    message(sprintf("idx: %d (%.1f%%) - %s", x,
                                  x * 100 / until, date()))
                }
                
                cpp_filter_step(x)
            }, mc.cores = cores)
        } else {
            ## Sequential function for debugging.  print(paste('Sequential version'))
            boosting_filter <- lapply(seq(1, until), function(x) {
                if ((((x - 1) %% progress) == 0)) {
                    message(sprintf("idx: %d (%.1f%%) - %s", x,
                                  x * 100 / until, date()))
                }
                
                cpp_filter_step(x)
            })
        }
        
        ## Important!: stop (free memory, else suitable memory is still blocked)
        cpp_filter_end()
        
        filter <-
            do.call("rbind", lapply(seq_along(boosting_filter), function(x) {
                return(as.data.frame(cbind(
                    as.integer(boosting_filter[[x]]),
                    as.integer(rep(x,
                                   length(
                                       boosting_filter[[x]]
                                   )))
                )))
            }))

        filter <- unique(t(apply(filter, 1, sort)))
        } else if (filter_method[1] == "skip"){
            if (verbose) message(paste("Netboost: Filtering (skip)"))
            filter <- t(utils::combn(x=ncol(datan),m=2))
        } else if (filter_method[1] == "spearman"){
            if (verbose) message(paste0("Netboost: Filtering (",
            filter_method[1],")"))
            combs <- utils::combn(x=ncol(datan),m=2)
            n <- nrow(datan)
            cor_thres <- stats::qt((1-0.025),df=(n-2))/sqrt(n-2)
            datan <- apply(X=datan,MARGIN=2,FUN=rank)
            index <- (parallel::mclapply(X=seq(
                from = 1,
                to = ncol(combs),
                by = 1
            ),
            FUN=function(i) {
			r <- abs(stats::cor(datan[,combs[1,i]], datan[,combs[2,i]], use = "pairwise.complete.obs", method = "pearson"))
#                r <- abs(WGCNA::cor(datan[, combs[1,i]],
#                               datan[, combs[2,i]], method = "pearson"))
                return((r/sqrt(1-r^2)) > cor_thres)
            },mc.cores=cores))
            filter <- t(combs[,unlist(index)])
        } else if (filter_method[1] == "pearson"){
            if (verbose) message(paste0("Netboost: Filtering (",
            filter_method[1],")"))
            combs <- utils::combn(x=ncol(datan),m=2)
            n <- nrow(datan)
            cor_thres <- stats::qt((1-0.025),df=(n-2))/sqrt(n-2)
            index <- (parallel::mclapply(X=seq(
                from = 1,
                to = ncol(combs),
                by = 1
            ),
            FUN=function(i) {
			r <- abs(stats::cor(datan[,combs[1,i]], datan[,combs[2,i]], use = "pairwise.complete.obs", method = filter_method[1]))
#                r <- abs(WGCNA::cor(datan[, combs[1,i]],
#                               datan[, combs[2,i]], method = filter_method[1]))
                return((r/sqrt(1-r^2)) > cor_thres)
            },mc.cores=cores))
            filter <- t(combs[,unlist(index)])
        } else if (filter_method[1] %in% c("kendall")){
            if (verbose) message(paste0("Netboost: Filtering (",
            filter_method[1],")"))
            combs <- utils::combn(x=ncol(datan),m=2)
            index <- parallel::mclapply(seq_len(ncol(combs)),FUN=function(i){
            stats::cor.test(x=datan[,combs[1,i]],y=datan[,
              combs[2,i]],alternative = "two.sided",
              method = filter_method[1])$p.value < 0.05
            }, mc.cores = cores)
            filter <- t(combs[,unlist(index)])
        } else {
            stop("filter_method in nb_filter not supported.")
        }
        colnames(filter) <- c("cluster_id1", "cluster_id2")
        rownames(filter) <- seq(from = 1,
                                to = nrow(filter),
                                by = 1)

        if (verbose) message("Netboost: Filter includes ",
        nrow(filter)," of ",(ncol(datan)*(ncol(datan)-1)/2)," potential edges.")
        return(filter)
    }

#' Plot dendrogram from Netboost output.
#'
#' @name nb_plot_dendro
#' @param nb_summary    Netboost results as generated by the nb_summary function.
#' @param labels    Boolean flag whether labels should be attached to
#'   the leafs.
#' @param main    Plot title.
#' @param colorsrandom    Boolean flag whether module colors should be
#'   shuffeled.
#' @return invisible null
#'
#' @examples
#' data('tcga_aml_meth_rna_chr18',  package='netboost')
#' results <- netboost(datan = tcga_aml_meth_rna_chr18, stepno = 20L,
#' soft_power = 3L, min_cluster_size = 10L, n_pc = 2, scale=TRUE,
#' ME_diss_thres = 0.25, qc_plot = FALSE)
#' set.seed(1234) # reproducible but shuffled color-module matching
#' nb_plot_dendro(nb_summary = results, labels = FALSE, main = 'Test',
#' colorsrandom = TRUE)
#'
#' @export
nb_plot_dendro <-
    function(nb_summary = NULL,
             labels = FALSE,
             main = "",
             colorsrandom = FALSE) {
        if (!exists("nb_summary"))
            stop("Netboost output (nb_summary) must be provided.")
        
        colorHeight <- 0.2
        graphics::layout(matrix(seq(
            from = 1,
            to = (2 * length(nb_summary[["dendros"]])),
            by = 1
        ),
        nrow = 2),
        heights = c(1 - colorHeight, colorHeight))
        
        last_col <- 0
        n_colors <- length(unique(nb_summary[["colors"]]))
        middle <- floor(n_colors / 2)
        if (colorsrandom) {
            shuffel_index <- sample(x = n_colors, size = n_colors)
        } else {
            shuffel_index <- seq(from = 1,
                                 to = n_colors,
                                 by = 1)
        }
        shuffel_index <-
            c(shuffel_index[(2 * middle + 1)][(2 * middle + 1) == n_colors],
              rbind(shuffel_index[seq(from = 1, to = middle, by = 1)], shuffel_index[seq(from = (middle +
                                                                                                     1),
                                                                                         to = (2 * middle),
                                                                                         by = 1)]))
        plot_colors <-
            colorspace::rainbow_hcl(n = (length(unique(
                nb_summary[["colors"]]
            ))))[shuffel_index][as.factor(nb_summary[["colors"]])]
        plot_colors[as.numeric(nb_summary[["colors"]]) <= 0] <- grDevices::gray(level = 0.7)
        for (tree in seq_along(nb_summary[["dendros"]])) {
            graphics::par(mar = c(0, 4, 8, 4))
            first_col <- last_col + 1
            last_col <-
                last_col + length(nb_summary[["dendros"]][[tree]][["labels"]])
            if (labels) {
                graphics::plot(nb_summary[["dendros"]][[tree]],
                     labels = nb_summary[["names"]][seq(from = first_col,
                                                   to = last_col,
                                                   by = 1)],
                     main = main)
            } else {
                graphics::plot(nb_summary[["dendros"]][[tree]],
                     labels = FALSE,
                     main = main)
            }
            graphics::par(mar = c(4, 4, 0, 4))
            WGCNA::plotColorUnderTree(nb_summary[["dendros"]][[tree]],
                                      colors = plot_colors[seq(from = first_col,
                                                               to = last_col,
                                                               by = 1)],
                                      rowLabels = "")
        }
        invisible(cbind(nb_summary[["colors"]],plot_colors))     # Only to not have empty value section
    }


#' Netboost module aggregate extraction.
#'
#' This is a modification of WGCNA::moduleEigengenes() (version WGCNA_1.66) to
#' include more than the first principal component. For details see
#' WGCNA::moduleEigengenes().
#'
#' @name nb_moduleEigengenes
#' @param expr    Expression data for a single set in the form of a data frame
#'   where rows are samples and columns are genes (probes).
#' @param colors    A vector of the same length as the number of probes in
#'   ‘expr’, giving module color for all probes (genes). Color ‘'grey'’ is
#'   reserved for unassigned genes.     Expression
#' @param n_pc    Number of principal components and variance explained
#'   entries to be calculated. The number of returned variance explained entries
#'   is currently ‘min(n_pc,10)’. If given ‘n_pc’ is greater than 10, a warning is
#'   issued.
#' @param align    Controls whether eigengenes, whose orientation is
#'   undetermined, should be aligned with average expression (‘align = 'along
#'   average'’, the default) or left as they are (‘align = ''’). Any other value
#'   will trigger an error.
#' @param exclude_grey    Should the improper module consisting of 'grey' genes be
#'   excluded from the eigengenes?
#' @param grey    Value of ‘colors’ designating the improper module. Note
#'   that if ‘colors’ is a factor of numbers, the default value will be
#'   incorrect.
#' @param subHubs    Controls whether hub genes should be substituted for
#'   missing eigengenes. If ‘TRUE’, each missing eigengene (i.e., eigengene
#'   whose calculation failed and the error was trapped) will be replaced by a
#'   weighted average of the most connected hub genes in the corresponding
#'   module. If this calculation fails, or if ‘subHubs==FALSE’, the value of
#'   ‘trapErrors’ will determine whether the offending module will be removed or
#'   whether the function will issue an error and stop.
#' @param robust	Should PCA be calculated on ranked data (Spearman PCA)?
#'   Rotations will not correspond to original data if this is applied.
#' @param trapErrors    Controls handling of errors from that may arise when
#'   there are too many ‘NA’ entries in expression data. If ‘TRUE’, errors from
#'   calling these functions will be trapped without abnormal exit.  If ‘FALSE’,
#'   errors will cause the function to stop. Note, however, that ‘subHubs’ takes
#'   precedence in the sense that if ‘subHubs==TRUE’ and ‘trapErrors==FALSE’, an
#'   error will be issued only if both the principal component and the hubgene
#'   calculations have failed.
#' @param return_valid_only    logical; controls whether the returned data frame of
#'   module eigengenes contains columns corresponding only to modules whose
#'   eigengenes or hub genes could be calculated correctly (‘TRUE’), or whether
#'   the data frame should have columns for each of the input color labels
#'   (‘FALSE’).
#' @param soft_power    The power used in soft-thresholding the adjacency
#'   matrix. Only used when the hubgene approximation is necessary because the
#'   principal component calculation failed. It must be non-negative. The
#'   default value should only be changed if there is a clear indication that it
#'   leads to incorrect results.
#' @param scale    logical; can be used to turn off scaling of the
#'   expression data before calculating the singular value decomposition. The
#'   scaling should only be turned off if the data has been scaled previously,
#'   in which case the function can run a bit faster. Note however that the
#'   function first imputes, then scales the expression data in each module. If
#'   the expression contain missing data, scaling outside of the function and
#'   letting the function impute missing data may lead to slightly different
#'   results than if the data is scaled within the function.
#' @param verbose    Controls verbosity of printed progress messages. 0 means
#'   silent, up to (about) 5 the verbosity gradually increases.
#' @param indent    A single non-negative integer controlling indentation of
#'   printed messages. 0 means no indentation, each unit above that adds two
#'   spaces.
#' @param nb_min_varExpl    Minimum proportion of variance explained for
#'   returned module eigengenes. Is capped at n_pc.
#'
#' @return eigengenes    Module eigengenes in a dataframe, with each column
#'   corresponding to one eigengene. The columns are named by the corresponding
#'   color with an ‘'ME'’ prepended, e.g., ‘MEturquoise’ etc. If
#'   ‘return_valid_only==FALSE’, module eigengenes whose calculation failed have
#'   all components set to ‘NA’.
#' @return averageExpr  If ‘align == 'along average'’, a dataframe containing
#'   average normalized expression in each module. The columns are named by the
#'   corresponding color with an ‘'AE'’ prepended, e.g., ‘AEturquoise’ etc.
#' @return var_explained A dataframe in which each column corresponds to a
#'   module, with the component ‘var_explained[PC, module]’ giving the variance
#'   of module ‘module’ explained by the principal component no. ‘PC’. The
#'   calculation is exact irrespective of the number of computed principal
#'   components. At most 10 variance explained values are recorded in this
#'   dataframe.
#' @return n_pc          A copy of the input ‘n_pc’.
#' @return validMEs     A boolean vector. Each component (corresponding to the
#'   columns in ‘data’) is ‘TRUE’ if the corresponding eigengene is valid, and
#'   ‘FALSE’ if it is invalid. Valid eigengenes include both principal
#'   components and their hubgene approximations. When ‘return_valid_only==FALSE’,
#'   by definition all returned eigengenes are valid and the entries of
#'   ‘validMEs’ are all ‘TRUE’.
#' @return validColors  A copy of the input colors with entries corresponding to
#'   invalid modules set to ‘grey’ if given, otherwise 0 if ‘colors’ is numeric
#'   and 'grey' otherwise.
#' @return allOK        Boolean flag signalling whether all eigengenes have been
#'   calculated correctly, either as principal components or as the hubgene
#'   average approximation.
#' @return allPC        Boolean flag signalling whether all returned eigengenes
#'   are principal components.
#' @return isPC         Boolean vector. Each component (corresponding to the
#'   columns in ‘eigengenes’) is ‘TRUE’ if the corresponding eigengene is the
#'   first principal component and ‘FALSE’ if it is the hubgene approximation or
#'   is invalid.
#' @return isHub        Boolean vector. Each component (corresponding to the
#'   columns in ‘eigengenes’) is ‘TRUE’ if the corresponding eigengene is the
#'   hubgene approximation and ‘FALSE’ if it is the first principal component or
#'   is invalid.
#' @return validAEs     Boolean vector. Each component (corresponding to the
#'   columns in ‘eigengenes’) is ‘TRUE’ if the corresponding module average
#'   expression is valid.
#' @return allAEOK      Boolean flag signalling whether all returned module
#'   average expressions contain valid data. Note that ‘return_valid_only==TRUE’
#'   does not imply ‘allAEOK==TRUE’: some invalid average expressions may be
#'   returned if their corresponding eigengenes have been calculated correctly.
#' @export
nb_moduleEigengenes <-
    function(expr,
             colors,
             n_pc = 1,
             align = "along average",
             exclude_grey = FALSE,
             grey = if (is.numeric(colors))
                 0
             else
                 "grey",
             subHubs = TRUE,
             robust = FALSE,
             trapErrors = FALSE,
             return_valid_only = trapErrors,
             soft_power = 6,
             scale = TRUE,
             verbose = 0,
             indent = 0,
             nb_min_varExpl = 0.5) {
        spaces <- indentSpaces(indent)
        
        if (verbose == 1)
            message(
                paste(
                    spaces,
                    "moduleEigengenes: Calculating",
                    nlevels(as.factor(colors)),
                    "module eigengenes in given set."
                )
            )
        
        if (is.null(expr)) {
            stop("moduleEigengenes: Error: expr is NULL. ")
        }
        
        if (is.null(colors)) {
            stop("moduleEigengenes: Error: colors is NULL. ")
        }
        
        if (is.null(dim(expr)) || length(dim(expr)) != 2)
            stop("moduleEigengenes: Error: expr must be two-dimensional.")
        
        if (dim(expr)[2] != length(colors))
            stop(
                "moduleEigengenes: Error: ncol(expr) and length(colors) must be equal (one color per gene)."
            )
        
        if (is.factor(colors)) {
            nl <- nlevels(colors)
            nlDrop <- nlevels(colors[, drop = TRUE])
            if (nl > nlDrop)
                stop(
                        "Argument 'colors' contains unused levels (empty modules). ",
                        "Use colors[, drop=TRUE] to get rid of them."
                )
        }
        
        if (soft_power < 0)
            stop("soft_power must be non-negative")
        
        alignRecognizedValues <- c("", "along average")
        
        if (!is.element(align, alignRecognizedValues)) {
            message(
                paste(
                    "ModulePrincipalComponents: Error:",
                    "parameter align has an unrecognised value:",
                    align,
                    "; Recognized values are ",
                    alignRecognizedValues
                )
            )
            stop()
        }
        
        maxVarExplained <- 10
        
        if (n_pc > maxVarExplained)
            warning(paste("Given n_pc is too large. Will use value", maxVarExplained))
        
        nVarExplained <- min(n_pc, maxVarExplained)
        modlevels <- levels(factor(colors))
        
        if (exclude_grey)
            if (sum(as.character(modlevels) != as.character(grey)) > 0) {
                modlevels <-
                    modlevels[as.character(modlevels) != as.character(grey)]
            } else {
                stop(
                        "Color levels are empty. Possible reason: the only color is grey",
                        " and grey module is excluded from the calculation."
                )
            }
        
        PrinComps <- data.frame(matrix(NA, nrow = dim(expr)[[1]],
                                       ncol = length(modlevels)))
        nb_PrinComps <- data.frame(matrix(NA, nrow = dim(expr)[[1]],
                                          ncol = 0))
        rotation <- vector("list", length(modlevels))
        averExpr <-
            data.frame(matrix(NA, nrow = dim(expr)[[1]],
                              ncol = length(modlevels)))
        varExpl <-
            data.frame(matrix(NA, nrow = nVarExplained,
                              ncol = length(modlevels)))
        validMEs <- rep(TRUE, length(modlevels))
        validAEs <- rep(FALSE, length(modlevels))
        isPC <- rep(TRUE, length(modlevels))
        isHub <- rep(FALSE, length(modlevels))
        validColors <- colors
        names(PrinComps) <-
            paste(moduleColor.getMEprefix(), modlevels, sep = "")
        names(averExpr) <- paste("AE", modlevels, sep = "")
        for (i in seq_along(modlevels)) {
            if (verbose > 1)
                message(paste(
                    spaces,
                    "moduleEigengenes : Working on ME for module",
                    modlevels[i]
                ))
            modulename <- modlevels[i]
            restrict1 <-
                as.character(colors) == as.character(modulename)
            if (verbose > 2)
                message(paste(spaces, " ...", sum(restrict1), "features"))
            datModule <- as.matrix(t(expr[, restrict1]))
            n <- dim(datModule)[2]
            p <- dim(datModule)[1]
            pc <- try({
                if (scale){
                	if (verbose > 5)
                    	message(paste(spaces, " ...scaling"))
                    datModule <- t(scale(t(datModule)))
                }
                if(robust){
                	if (verbose > 5)
                    	message(paste(spaces, " ...ranking"))
                    datModule <- apply(X=datModule,MARGIN=1,FUN=rank)
                    datModule <- t(scale(datModule))
                }
                if (verbose > 5)
                    message(paste(spaces, " ...calculating SVD"))
                svd1 <-
                    svd(datModule,
                        nu = min(n, p, n_pc),
                        nv = min(n, p, n_pc))
                nb_PCA <- stats::prcomp(
                        x = t(datModule),
                        retx = TRUE,
                        center = FALSE,
                        scale. = FALSE,
                        tol = NULL,
                        rank. = NULL)
                nb_PCA[["x"]] <- t(t(nb_PCA[["x"]]) / svd1[["d"]])
                nb_PCA[["rotation"]] <- t(t(nb_PCA[["rotation"]]) / svd1[["d"]])
                if (verbose > 5)
                    message(paste(spaces, " ...calculating PVE"))
                veMat <-
                    WGCNA::cor(svd1[["v"]][, seq(from = 1,
                                            to = min(n, p, nVarExplained),
                                            by = 1)], t(datModule), use = "p")
                varExpl[seq(
                    from = 1,
                    to = min(n, p, nVarExplained),
                    by = 1
                ), i] <- rowMeans(veMat ^ 2,
                                  na.rm = TRUE)
                svd1[["v"]][, 1]
            }, silent = TRUE)
            
            if (methods::is(pc, "try-error")) {
                if (!trapErrors)
                    stop(pc)
                if (verbose > 0) {
                    message(
                        paste(
                            spaces,
                            " ..ME calculation of module",
                            modulename,
                            "failed with the following error:"
                        )
                    )
                    message(
                        paste(
                            spaces,
                            "     ",
                            pc,
                            spaces,
                            " ..the offending module has been removed."
                        )
                    )
                }
                warning(
                    paste(
                        "Eigengene calculation of module",
                        modulename,
                        "failed with the following error \n     ",
                        pc,
                        "The offending module has been removed.\n"
                    )
                )
                validMEs[i] <- FALSE
                isPC[i] <- FALSE
                isHub[i] <- FALSE
                validColors[restrict1] <- grey
            } else {
                PrinComps[, i] <- pc
                nb_n_pcs <-
                    min(c(which(
                        cumsum(varExpl[seq(
                            from = 1,
                            to = min(n, p,
                                     nVarExplained),
                            by = 1
                        ), i]) > nb_min_varExpl
                    ), nVarExplained))
                nb_PrinComps <-
                    base::cbind(nb_PrinComps, nb_PCA[["x"]][, seq(from = 1,
                                                       to = nb_n_pcs,
                                                       by = 1)])
                colnames(nb_PrinComps)[seq(
                    from = (ncol(nb_PrinComps) - nb_n_pcs + 1),
                    to = ncol(nb_PrinComps),
                    by = 1
                )] <- paste0(
                    moduleColor.getMEprefix(),
                    modlevels[i],
                    "_pc",
                    seq(
                        from = 1,
                        to = nb_n_pcs,
                        by = 1
                    )
                )
                colnames(nb_PCA[["rotation"]])[seq(from = 1,
                                              to = nb_n_pcs,
                                              by = 1)] <- paste0(
                                                  moduleColor.getMEprefix(),
                                                  modlevels[i],
                                                  "_pc",
                                                  seq(
                                                      from = 1,
                                                      to = nb_n_pcs,
                                                      by = 1
                                                  )
                                              )
                rotation[[i]] <-
                    nb_PCA[["rotation"]][, seq(from = 1,
                                          to = nb_n_pcs,
                                          by = 1),
                                    drop = FALSE]
                ae <- try({
                    if (isPC[i])
                        scaledExpr <- scale(t(datModule))
                    averExpr[, i] <-
                        rowMeans(scaledExpr, na.rm = TRUE)
                    if (align == "along average") {
                        if (verbose > 4)
                            message(
                                paste(
                                    spaces,
                                    " .. aligning module eigengene with average expression."
                                )
                            )
                        corAve <-
                            WGCNA::cor(averExpr[, i], PrinComps[, i], use = "p")
                        if (!is.finite(corAve))
                            corAve <- 0
                        if (corAve < 0)
                            PrinComps[, i] <- -PrinComps[, i]
                    }
                    0
                }, silent = TRUE)
                if (methods::is(ae, "try-error")) {
                    if (!trapErrors)
                        stop(ae)
                    if (verbose > 0) {
                        message(
                            paste(
                                spaces,
                                " ..Average expression calculation of module",
                                modulename,
                                "failed with the following error:"
                            )
                        )
                        message(
                            paste(
                                spaces,
                                "     ",
                                ae,
                                spaces,
                                " ..the returned average expression ",
                                "vector will be invalid."
                            )
                        )
                    }
                    warning(
                        paste(
                            "Average expression calculation of module",
                            modulename,
                            "failed with the following error \n     ",
                            ae,
                            "The returned average expression vector will",
                            " be invalid.\n"
                        )
                    )
                }
                validAEs[i] <- !methods::is(ae, "try-error")
            }
        }
        
        allOK <- (sum(!validMEs) == 0)
        if (return_valid_only && sum(!validMEs) > 0) {
            PrinComps <- PrinComps[, validMEs]
            averExpr <- averExpr[, validMEs]
            varExpl <- varExpl[, validMEs]
            validMEs <- rep(TRUE, times = ncol(PrinComps))
            isPC <- isPC[validMEs]
            isHub <- isHub[validMEs]
            validAEs <- validAEs[validMEs]
        }
        
        allPC <- (sum(!isPC) == 0)
        allAEOK <- (sum(!validAEs) == 0)
        list(
            eigengenes = PrinComps,
            averageExpr = averExpr,
            var_explained = varExpl,
            n_pc = n_pc,
            validMEs = validMEs,
            validColors = validColors,
            allOK = allOK,
            allPC = allPC,
            isPC = isPC,
            isHub = isHub,
            validAEs = validAEs,
            allAEOK = allAEOK,
            nb_eigengenes = nb_PrinComps,
            rotation = rotation
        )
    }

## #' Example to get access to the MCUPGMA executables.
## #' 
## #' @examples
## #' mcupgma_example()
## #' @export
## mcupgma_example <- function() {
##     exec <- netboostMCUPGMAPath()
##     files <- Sys.glob(file.path(exec, "*"))
##     paste("Available MCUPGMA executables and scripts under:", exec)
##     print(sapply(files, basename, USE.NAMES = FALSE))
## }

## #' Test/example code. Applies netboost to the TCGA-AML CHR18 DNA methylation and
## #' gene expression data supplied with the package.
## #'
## #' @param cores Integer. CPU cores to use.
## #' @param keep Logical. Keep mcupgma intermediate files.
## #' @return Netboost result
## #'
## #' @examples
## #' nb_example()
## #'
## #' @export
# nb_example <-
#     function(cores = getOption("mc.cores", 2L),
#              keep = FALSE) {
#         # Keep data local.
#         exa_env <- new.env()
#         
#         # load data methylation and RNA data 180 patients x 5283 features
#         data("tcga_aml_meth_rna_chr18",
#              package = "netboost",
#              envir = exa_env)
#         
#         pdfFile <- file.path(tempdir(), "results_netboost.pdf")
#         
#         # pdf(file=file.path(getwd(), 'results_netboost.pdf'), width = 30)
#         pdf(file = pdfFile, width = 30)
#         results <-
#             netboost(
#                 datan = exa_env[["tcga_aml_meth_rna_chr18"]],
#                 stepno = 20L,
#                 soft_power = 3L,
#                 min_cluster_size = 10L,
#                 n_pc = 2,
#                 scale = TRUE,
#                 ME_diss_thres = 0.25
#             )
#         # set.seed(1234)
#         nb_plot_dendro(nb_summary = results,
#                        labels = TRUE,
#                        colorsrandom = TRUE)
#         dev.off()
#         
#         if (file.exists(pdfFile)) {
#             message(paste0("PDF created:", pdfFile))
#             
#             # If default PDF viewer is assigned, try to show PDF.
#             if (!is.null(getOption("pdfviewer"))) {
#       #          system2(getOption("pdfviewer"), pdfFile)
#             }
#         }
#         
#         ### Transfer results to the same data (bug check)
#         ME_transfer <-
#             nb_transfer(
#                 nb_summary = results,
#                 new_data = exa_env[["tcga_aml_meth_rna_chr18"]],
#                 scale = TRUE
#             )
#         
#         all(round(results[["MEs"]], 12) == round(ME_transfer, 12))
#         
#         # Cleanup all produced temporary filed (esp. clustering/iteration_*)
#         if (!keep)
#             netboostTmpCleanup()
#         else
#             message(paste("Kept MCUPGMA temporary files in:", netboostTmpPath()))
#         
#         invisible(results)
#     }

#' @name tcga_aml_meth_rna_chr18
#' @title TCGA RNA and methylation measurement on a subset of
#' chromosome 18 for 80 AML patients.
#' @docType data
#' @usage tcga_aml_meth_rna_chr18
#' @format A data frame with 80 rows (patients) and 500 variables (features).
#' @source \url{https://portal.gdc.cancer.gov/}
NULL

# Generated by using Rcpp::compileAttributes() -> do not edit by hand
# Generator token: 10BE3573-1514-4C36-9D1C-5A225CD40393

#' @title Initialise boosting with chosen accelerator hardware (x86, AVX, FMA)
#' 
#' @param data Matrix
#' @param stepno Amount of steps
#' @param mode_ Accelerator mode (0: x86, 1: FMA, 2: AVX)
#' @return none
cpp_filter_base <- function(data, stepno = 20L, mode_ = 2L) {
    invisible(.Call('_netboost_filter_base', PACKAGE = 'netboost', data, stepno, mode_))
}

#' @title Boosting cleanup (required to free memory)
#' 
#' @return none
cpp_filter_end <- function() {
    invisible(.Call('_netboost_filter_end', PACKAGE = 'netboost'))
}

#' @title Single boosting step
#' 
#' @details Must be initialised before using @see{filter_base}
#' 
#' @param col_y Row in data matrix
#' @return integer vector
cpp_filter_step <- function(col_y) {
    .Call('_netboost_rcpp_filter_step', PACKAGE = 'netboost', col_y)
}

#' @title Function to calcutate distance
#' @details
#' Steps:
#'   1. - Sequential preparation of index and partner caches per value in filter
#'   2. - Parallel calculation of the distances with cached vectors
#'
#' @param filter Filter matrix
#' @param adjacency Vector
#' @return numeric vector
cpp_dist_tom <- function(filter, adjacency) {
    .Call('_netboost_dist_tom', PACKAGE = 'netboost', filter, adjacency)
}

#' @title Tree search.
#' @name cpp_tree_search
#' 
#' @description
#' Constraint: IDs 0 <= x (Integer)
#' 
#' @backref src/tree_sort.cpp 
#'
#' @param netboost_forest Input-matrix (4 columns, ids in colum 0,1,3)
#' @return List
#'
cpp_tree_search <- function(netboost_forest) {
    .Call('_netboost_tree_search', PACKAGE = 'netboost', netboost_forest)
}

#!/bin/csh
##########################################################################
# MC-UPGMA  - Accurate huge scale clustering by Memory Constrained UPGMA #
#             Loewenstein et al. Bioinformatics. 2008 Jul 1;24(13):i41-9.#
#                                                                        #
# Copyright (C) 2007, Yaniv Loewenstein                                  #
#                School of Computer Science And Engineering              #
#                Hebrew University of Jerusalem                          #
#                                                                        #
#      All Rights Reserved                                               #
#                                                                        #
#      This source code is distributed under the terms of the            #
#      GNU General Public License. See the file LICENSE                  #
#      for details.                                                      #
#                                                                        #
##########################################################################


#foreach d (iteration_? iteration_?? iteration_???)

tail -n1 iteration_?/tree* iteration_??/tree* iteration_???/tree* | removeBlankLines.pl \
	| awk '{if (/=/) { printf "%s\tlast merge:", $2;} else {print "E = "$3,"\tID = "$4;}}'

#!/bin/csh

##########################################################################
# MC-UPGMA  - Accurate huge scale clustering by Memory Constrained UPGMA #
#             Loewenstein et al. Bioinformatics. 2008 Jul 1;24(13):i41-9.#
#                                                                        #
# Copyright (C) 2007, Yaniv Loewenstein                                  #
#                School of Computer Science And Engineering              #
#                Hebrew University of Jerusalem                          #
#                                                                        #
#      All Rights Reserved                                               #
#                                                                        #
#      This source code is distributed under the terms of the            #
#      GNU General Public License. See the file LICENSE                  #
#      for details.                                                      #
#                                                                        #
##########################################################################

# Usage: records how many edges remain in *.edges.gz files per iteration_X folder into iteration_X.count

foreach dir (iteration_? iteration_?? iteration_???)
	test -s $dir.count || scat $dir/*.edges.gz | wc -l >>! $dir.count
end

---
title: "The Netboost users guide"
author: "Pascal Schlosser, Jochen Knaus"
package: "`r pkg_ver('netboost')`"
output: 
  BiocStyle::html_document:
    md_extensions: "-autolink_bare_uris"
vignette: >
  %\VignetteIndexEntry{The Netboost users guide}
  %\VignetteEngine{knitr::rmarkdown}
  %\VignetteEncoding{UTF-8}  
---

```{r setup, cache = F, echo = FALSE}
knitr::opts_chunk$set(error = TRUE)
```

# Introduction

The `r Biocpkg("netboost")` package, implements a three-step dimension reduction
technique. First, a boosting-based filter is combined with the topological 
overlap measure to identify the essential edges of the network. Second, sparse 
hierarchical clustering is applied on the selected edges to identify modules
and finally module information is aggregated by the first principal 
components. The primary analysis is then carried out on these summary measures
instead of the original data.

# Loading an example dataset 

The package comes with an example dataset included. We import the acute myeloid 
leukemia patient data from The Cancer Genome Atlas public domain database. 
The dataset consists of one thousand DNA methylation sites and gene expression levels on 
chromosome 18 for 80 patients.

```{r load_data}
require("netboost")
data("tcga_aml_meth_rna_chr18", package = "netboost")
dim(tcga_aml_meth_rna_chr18)
```

The `netboost()` function integrates all major analysis steps and generates 
multiple plots. In this step we also set analysis parameters:

 `stepno` defines the number of boosting steps taken

 `soft_power` (if null, automatically chosen) the exponent in the transformation
of the correlation

 `min_cluster_size` the minimal size of clusters, `n_pc` the number of maximally 
computed principal components

 `scale` if data should be scaled and centered prior to analysis

 `ME_diss_thres` defines the merging threshold for identified clusters. 

 For details on the options please see `?netboost` and the corresponding paper
Schlosser et al. 2020.

```{r netboost_run}
results <- netboost(datan = tcga_aml_meth_rna_chr18, stepno = 20L, 
soft_power = 3L, min_cluster_size = 10L, n_pc = 2, scale = TRUE, ME_diss_thres = 0.25) 
```

For each detected 
independent tree in the dataset (here one) the first graph shows a dendrogram of 
initial modules and at which level they are merged, the second graph a module 
dendrogram after merging and the third the dendrogram of features including the 
module-color-code.

`results` contains the dendrograms (dendros), feature identifier (names) matched 
to module assignment (colors), the aggregated dataset (MEs), the rotation matrix 
to compute the aggregated dataset (rotation) and the proportion of variance 
explained by the aggregate measures (var_explained).
Dependent on the minimum proportion of variance explained set in the 
`netboost()` call (default 0.5) up to `n_pc` principal components are exported.

```{r results}
names(results)
colnames(results$MEs)
```

As you see for most modules the first principal component already explained more 
than 50% of the variance in the original features of this module. 
ME0_*X*_pc*Y* denotes the background module (unclustered features) of the 
independent tree *X*.

Explained variance is reported by a matrix for the first `n_pc` principal 
components. Here we list the first 5 modules:

```{r variance}
results$var_explained[,1:5]
```

`results$colors` use a numeric coding for the modules which matches their module 
name. To list features of module ME8 we can extract them by:

```{r module_members}
results$names[results$colors==8]
```

The final dendrogram including all trees can be plotted including labels (`results$names`) for 
individual features. `colorsrandom` controls if module-color matching should be 
randomized to get a clearly differentiable pattern of the potentially many 
modules. Labels are only suitable in applications with few features or with a 
appropriately large pdf device.

```{r plot}
set.seed(123)
nb_plot_dendro(nb_summary = results, labels = FALSE, colorsrandom = TRUE)
```

Next the primary analysis on the aggregated dataset (`results$MEs`) can be 
computed.
We also implemented a convenience function to transfer a clustering to a new 
dataset. Here, we transfer the clustering to the same dataset resulting in 
identical aggregate measures.

```{r transfer}
    ME_transfer <- nb_transfer(nb_summary = results, 
    new_data = tcga_aml_meth_rna_chr18, scale = TRUE)
    all(round(results$MEs, 10) == round(ME_transfer, 10))
```

Netboost now also has a fully non-parametric implementation. Code is not run here to showcase the multicore option (Bioconductor vignette builder does not allow for multicore execution). Adjust `cores` to your machine:
```{r robust_netboost_run}
#results <- netboost(datan = tcga_aml_meth_rna_chr18,cores=10L,
#soft_power = 3L, min_cluster_size = 10L, n_pc = 2, qc_plot = FALSE,
#filter_method = "spearman", robust_PCs = TRUE, method = "spearman")
```

# Session Info
```{r sessionInfo}
sessionInfo()
warnings()
```

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/netboost.R
\name{nb_mcupgma}
\alias{nb_mcupgma}
\title{Calculate dendrogram for a sparse distance matrix
(external wrapper MC-UPGMA clustering package Loewenstein et al.}
\usage{
nb_mcupgma(
  filter,
  dist,
  max_singleton,
  cores = getOption("mc.cores", 2L),
  verbose = getOption("verbose")
)
}
\arguments{
\item{filter}{Filter-Matrix as generated by the nb_filter function.}

\item{dist}{Distance-Matrix as generated by the nb_dist function.}

\item{max_singleton}{Integer The maximal singleton in the clustering.
Usually equals the number of features.}

\item{cores}{Integer Amount of CPU cores used (<=1 : sequential)}

\item{verbose}{Logical Additional diagnostic messages.}
}
\value{
Raw dendrogram to be processed by tree_search and tree_dendro.
}
\description{
Calculate dendrogram for a sparse distance matrix
(external wrapper MC-UPGMA clustering package Loewenstein et al.
}
\examples{
   data('tcga_aml_meth_rna_chr18', package='netboost')
   cores <- as.integer(getOption('mc.cores', 2))
   datan <- as.data.frame(scale(tcga_aml_meth_rna_chr18,
   center=TRUE, scale=TRUE))
   filter <- nb_filter(datan=datan, stepno=20L, until=0L,
                       progress=1000L, cores=cores, mode=2L)
   dist <- nb_dist(datan=datan, filter=filter, soft_power=3L, cores=cores)
   max_singleton = dim(tcga_aml_meth_rna_chr18)[2]
   forest <- nb_mcupgma(filter=filter, dist=dist,
                        max_singleton=max_singleton, cores=cores)
 head(forest)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/data.R
\docType{data}
\name{tcga_aml_meth_rna_chr18}
\alias{tcga_aml_meth_rna_chr18}
\title{TCGA RNA and methylation measurement on a subset of
chromosome 18 for 80 AML patients.}
\format{
A data frame with 80 rows (patients) and 500 variables (features).
}
\source{
\url{https://portal.gdc.cancer.gov/}
}
\usage{
tcga_aml_meth_rna_chr18
}
\description{
TCGA RNA and methylation measurement on a subset of
chromosome 18 for 80 AML patients.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/netboost.R
\name{nb_summary}
\alias{nb_summary}
\title{Summarize results from a forest. Plot trees together.}
\usage{
nb_summary(clust_res)
}
\arguments{
\item{clust_res}{Clustering results from cut_trees call.}
}
\value{
List
}
\description{
Summarize results from a forest. Plot trees together.
}
\examples{
data('tcga_aml_meth_rna_chr18',  package='netboost')
 cores <- as.integer(getOption('mc.cores', 2))
 datan <- as.data.frame(scale(tcga_aml_meth_rna_chr18, center=TRUE,
 scale=TRUE))
 filter <- nb_filter(datan=datan, stepno=20L, until=0L, progress=1000L,
 cores=cores,mode=2L)
 dist <- nb_dist(datan=datan, filter=filter, soft_power=3L, cores=cores)
 max_singleton = dim(tcga_aml_meth_rna_chr18)[2]
 forest <- nb_mcupgma(filter=filter,dist=dist,max_singleton=max_singleton,
 cores=cores)
 trees <- tree_search(forest)
 results <- cut_trees(trees=trees,datan=datan, forest=forest,
 min_cluster_size=10L, ME_diss_thres=0.25, qc_plot=FALSE)
 sum_res <- nb_summary(clust_res=results)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/netboost.R
\name{nb_dist}
\alias{nb_dist}
\title{Calculate distance (external wrapper for internal C++ function)
Parallelisation inside C++ program with RcppParallel.}
\usage{
nb_dist(
  filter,
  datan,
  soft_power = 2,
  cores = getOption("mc.cores", 2L),
  verbose = getOption("verbose"),
  method = c("pearson", "kendall", "spearman")
)
}
\arguments{
\item{filter}{Filter-Matrix as generated by the nb_filter function.}

\item{datan}{Data frame were rows correspond to samples and columns to
features.}

\item{soft_power}{Integer. Exponent of the transformation. Set 
automatically based on the scale free topology criterion if unspecified.}

\item{cores}{Integer. Amount of CPU cores used (<=1 : sequential).}

\item{verbose}{Additional diagnostic messages.}

\item{method}{A character string specifying the method to be used for
correlation coefficients.}
}
\value{
Vector with distances.
}
\description{
Calculate distance (external wrapper for internal C++ function)
Parallelisation inside C++ program with RcppParallel.
}
\examples{
 data('tcga_aml_meth_rna_chr18', package='netboost')
 cores <- as.integer(getOption('mc.cores', 2))
 datan <- as.data.frame(scale(tcga_aml_meth_rna_chr18, center=TRUE,
 scale=TRUE))
 filter <- nb_filter(datan=datan, stepno=20L, until=0L, progress=1000L,
 cores=cores,mode=2L)
 dist <- nb_dist(datan=datan, filter=filter, soft_power=3L, cores=cores)
 summary(dist)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/zzz.R
\name{netboostPackagePath}
\alias{netboostPackagePath}
\title{Returns the absolute path to "exec" folder in the package.}
\usage{
netboostPackagePath()
}
\value{
Absolute path of installed package
}
\description{
Returns the absolute path to "exec" folder in the package.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tools.R
\name{netboostTmpCleanup}
\alias{netboostTmpCleanup}
\title{Cleans the netboost temporary folder. This can be useful during the session
as mcupgma creates vast directory structures (for iterations).
Creates the own folder (all netboost temporary data is stored in
netboostTmpPath(), which is equal to tempdir()/netboost).
Also used for first time setup of folder.}
\usage{
netboostTmpCleanup(verbose = FALSE)
}
\arguments{
\item{verbose}{Flag verbose}
}
\value{
none
}
\description{
Cleans the netboost temporary folder. This can be useful during the session
as mcupgma creates vast directory structures (for iterations).
Creates the own folder (all netboost temporary data is stored in
netboostTmpPath(), which is equal to tempdir()/netboost).
Also used for first time setup of folder.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/zzz.R
\name{.onAttach}
\alias{.onAttach}
\title{Package startup: used to fetch installation path of the own package,
as required for executing binary programs delivered with it.}
\usage{
.onAttach(libname, pkgname)
}
\arguments{
\item{libname}{Path to R installation (base package dir)}

\item{pkgname}{Package name (should be "netboost")}
}
\value{
none
}
\description{
Package startup: used to fetch installation path of the own package,
as required for executing binary programs delivered with it.
}
\examples{
\dontrun{nb_example()}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/netboost.R
\name{cut_dendro}
\alias{cut_dendro}
\title{Module detection for an individual tree}
\usage{
cut_dendro(
  tree_dendro,
  min_cluster_size = 2L,
  datan,
  ME_diss_thres,
  name_of_tree = "",
  qc_plot = TRUE,
  n_pc = 1,
  robust_PCs = FALSE,
  nb_min_varExpl = 0.5,
  method = c("pearson", "kendall", "spearman")
)
}
\arguments{
\item{tree_dendro}{List of tree specific objects including dendrogram, 
tree
data and features originating from the tree_dendro function.}

\item{min_cluster_size}{Integer. The minimum number of features in one 
module.}

\item{datan}{Data frame were rows correspond to samples and columns to
features.}

\item{ME_diss_thres}{Numeric. Module Eigengene Dissimilarity Threshold for
merging close modules.}

\item{name_of_tree}{String. Annotating plots and messages.}

\item{qc_plot}{Logical. Should plots be created?}

\item{n_pc}{Number of principal components and variance explained
entries to be calculated. The number of returned variance explained entries
is currently ‘min(n_pc,10)’. If given ‘n_pc’ is greater than 10, a warning 
is issued.}

\item{robust_PCs}{Should PCA be calculated on ranked data (Spearman PCA)?
Rotations will not correspond to original data if this is applied.}

\item{nb_min_varExpl}{Minimum proportion of variance explained for
returned module eigengenes. The number of PCs is capped at n_pc.}

\item{method}{A character string specifying the method to be used for
correlation coefficients.}
}
\value{
List
}
\description{
Module detection for an individual tree
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/netboost.R
\name{nb_clust}
\alias{nb_clust}
\title{Netboost clustering step}
\usage{
nb_clust(
  filter,
  dist,
  datan,
  max_singleton = dim(datan)[2],
  min_cluster_size = 2L,
  ME_diss_thres = 0.25,
  cores = getOption("mc.cores", 2L),
  qc_plot = TRUE,
  n_pc = 1,
  robust_PCs = FALSE,
  nb_min_varExpl = 0.5,
  method = c("pearson", "kendall", "spearman")
)
}
\arguments{
\item{filter}{Filter-Matrix as generated by the nb_filter function.}

\item{dist}{Distance-Matrix as generated by the nb_dist function.}

\item{datan}{Data frame were rows correspond to samples and columns to
features.}

\item{max_singleton}{Integer. The maximal singleton in the clustering.
Usually equals the number of features.}

\item{min_cluster_size}{Integer. The minimum number of features in one 
module.}

\item{ME_diss_thres}{Numeric. Module Eigengene Dissimilarity Threshold for
merging close modules.}

\item{cores}{Integer. Amount of CPU cores used (<=1 : sequential)}

\item{qc_plot}{Logical. Create plot.}

\item{n_pc}{Number of principal components and variance explained
entries to be calculated. The number of returned variance explained entries
is currently ‘min(n_pc,10)’. If given ‘n_pc’ is greater than 10, a warning 
is issued.}

\item{robust_PCs}{Should PCA be calculated on ranked data (Spearman PCA)?
Rotations will not correspond to original data if this is applied.}

\item{nb_min_varExpl}{Minimum proportion of variance explained for
returned module eigengenes. The number of PCs is capped at n_pc.}

\item{method}{A character string specifying the method to be used for
correlation coefficients.}
}
\value{
List
}
\description{
Netboost clustering step
}
\examples{
 data('tcga_aml_meth_rna_chr18',  package='netboost')
 cores <- as.integer(getOption('mc.cores', 2))
 datan <- as.data.frame(scale(tcga_aml_meth_rna_chr18, center=TRUE, 
 scale=TRUE))
 filter <- nb_filter(datan=datan, stepno=20L, until=0L, progress=1000L,
 cores=cores,mode=2L)
 dist <- nb_dist(datan=datan, filter=filter, soft_power=3L, cores=cores)
 max_singleton = dim(tcga_aml_meth_rna_chr18)[2]
 pdf("test.pdf",width=30)
 sum_res <- nb_clust(filter=filter, dist=dist, datan=datan,
 max_singleton=max_singleton, min_cluster_size=10L, ME_diss_thres=0.25,
 cores=cores, qc_plot=TRUE, n_pc=2L, nb_min_varExpl=0.5)
 dev.off()
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{cpp_filter_end}
\alias{cpp_filter_end}
\title{Boosting cleanup (required to free memory)}
\usage{
cpp_filter_end()
}
\value{
none
}
\description{
Boosting cleanup (required to free memory)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/zzz.R
\name{netboostTmpPath}
\alias{netboostTmpPath}
\title{Returns the absolute path to temporary folder of the package.
To change temporary path, use normal R variables (TEMPDIR etc).}
\usage{
netboostTmpPath()
}
\value{
Absolute path for "exec" folder
}
\description{
Returns the absolute path to temporary folder of the package.
To change temporary path, use normal R variables (TEMPDIR etc).
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/netboost.R
\name{cut_trees}
\alias{cut_trees}
\title{Module detection for the results from a nb_mcupgma call}
\usage{
cut_trees(
  trees,
  datan,
  forest,
  min_cluster_size = 2L,
  ME_diss_thres,
  qc_plot = TRUE,
  n_pc = 1,
  robust_PCs = FALSE,
  nb_min_varExpl = 0.5,
  method = c("pearson", "kendall", "spearman")
)
}
\arguments{
\item{trees}{List of trees, where one tree is a list of ids and rows}

\item{datan}{Data frame were rows correspond to samples and columns to
features.}

\item{forest}{Raw dendrogram-matrix as generated by the nb_mcupgma 
function.}

\item{min_cluster_size}{Integer. The minimum number of features in one
module.}

\item{ME_diss_thres}{Numeric. Module Eigengene Dissimilarity Threshold for
merging close modules.}

\item{qc_plot}{Logical. Should plots be created?}

\item{n_pc}{Number of principal components and variance explained
entries to be calculated. The number of returned variance explained entries
is currently ‘min(n_pc,10)’. If given ‘n_pc’ is greater than 10, a warning 
is issued.}

\item{robust_PCs}{Should PCA be calculated on ranked data (Spearman PCA)?
Rotations will not correspond to original data if this is applied.}

\item{nb_min_varExpl}{Minimum proportion of variance explained for
returned module eigengenes. The number of PCs is capped at n_pc.}

\item{method}{A character string specifying the method to be used for
correlation coefficients.}
}
\value{
List
}
\description{
Module detection for the results from a nb_mcupgma call
}
\examples{
data('tcga_aml_meth_rna_chr18',  package='netboost')
 cores <- as.integer(getOption('mc.cores', 2))
 datan <- as.data.frame(scale(tcga_aml_meth_rna_chr18, center=TRUE,
 scale=TRUE))
 filter <- nb_filter(datan=datan, stepno=20L, until=0L, progress=1000L,
 cores=cores,mode=2L)
 dist <- nb_dist(datan=datan, filter=filter, soft_power=3L, cores=cores)
 max_singleton = dim(tcga_aml_meth_rna_chr18)[2]
 forest <- nb_mcupgma(filter=filter, dist=dist, max_singleton=max_singleton,
 cores=cores)
 trees <- tree_search(forest)
 results <- cut_trees(trees=trees,datan=datan, forest=forest,
 min_cluster_size=10L, ME_diss_thres=0.25, qc_plot=TRUE)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/netboost.R
\name{nb_transfer}
\alias{nb_transfer}
\title{Transfer of Netboost clustering to new data.}
\usage{
nb_transfer(
  nb_summary = NULL,
  new_data = NULL,
  scale = FALSE,
  robust_PCs = FALSE,
  only_module_membership = FALSE
)
}
\arguments{
\item{nb_summary}{Netboost results as generated by the nb_summary 
function.}

\item{new_data}{Data frame were rows correspond to samples and columns to
features.}

\item{scale}{Logical. Should data be scaled and centered?}

\item{robust_PCs}{Should PCA be calculated on ranked data (Spearman PCA)?
Rotations will not correspond to original data if this is applied.}

\item{only_module_membership}{Logical. Should only module memberships be
transfered and PCs be newly computed?}
}
\value{
List
}
\description{
Transfer of Netboost clustering to new data.
}
\examples{
data('tcga_aml_meth_rna_chr18',  package='netboost')
results <- netboost(datan = tcga_aml_meth_rna_chr18, stepno = 20L,
    soft_power = 3L, min_cluster_size = 10L, n_pc = 2, scale=TRUE,
    ME_diss_thres = 0.25, qc_plot=FALSE)
ME_transfer <- nb_transfer(nb_summary = results,
    new_data = tcga_aml_meth_rna_chr18,
    scale = TRUE)
all(round(results[["MEs"]], 12) == round(ME_transfer, 12))

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/netboost.R
\name{nb_plot_dendro}
\alias{nb_plot_dendro}
\title{Plot dendrogram from Netboost output.}
\usage{
nb_plot_dendro(
  nb_summary = NULL,
  labels = FALSE,
  main = "",
  colorsrandom = FALSE
)
}
\arguments{
\item{nb_summary}{Netboost results as generated by the nb_summary function.}

\item{labels}{Boolean flag whether labels should be attached to
the leafs.}

\item{main}{Plot title.}

\item{colorsrandom}{Boolean flag whether module colors should be
shuffeled.}
}
\value{
invisible null
}
\description{
Plot dendrogram from Netboost output.
}
\examples{
data('tcga_aml_meth_rna_chr18',  package='netboost')
results <- netboost(datan = tcga_aml_meth_rna_chr18, stepno = 20L,
soft_power = 3L, min_cluster_size = 10L, n_pc = 2, scale=TRUE,
ME_diss_thres = 0.25, qc_plot = FALSE)
set.seed(1234) # reproducible but shuffled color-module matching
nb_plot_dendro(nb_summary = results, labels = FALSE, main = 'Test',
colorsrandom = TRUE)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/netboost.R
\name{netboost}
\alias{netboost}
\title{Netboost clustering.}
\usage{
netboost(
  datan = NULL,
  stepno = 20L,
  filter_method = c("boosting", "skip", "kendall", "spearman", "pearson"),
  until = 0L,
  progress = 1000L,
  mode = 2L,
  soft_power = NULL,
  max_singleton = ncol(datan),
  qc_plot = TRUE,
  min_cluster_size = 2L,
  ME_diss_thres = 0.25,
  n_pc = 1,
  robust_PCs = FALSE,
  nb_min_varExpl = 0.5,
  cores = as.integer(getOption("mc.cores", 2)),
  scale = TRUE,
  method = c("pearson", "kendall", "spearman"),
  verbose = getOption("verbose")
)
}
\arguments{
\item{datan}{Data frame were rows correspond to samples and columns to
features.}

\item{stepno}{Integer amount of boosting steps applied in the filtering
step}

\item{filter_method}{The following filtering methods are supported:
"boosting" (non-zero coefficients in likelihood based boosting),
"skip" (no filter), "kendall" (stats::cor.test),
"spearman" (stats::cor.test), "pearson" (stats::cor.test)}

\item{until}{Stop at index/column (if 0: iterate through all columns).
For testing purposes in large datasets.}

\item{progress}{Integer. If > 0, print progress after every X steps (
Progress might not be reported completely accurate due to parallel execution)}

\item{mode}{Integer. Mode (0: x86, 1: FMA, 2: AVX). Features are only
available if compiled accordingly and available on the hardware.}

\item{soft_power}{Integer. Exponent of the transformation. Set
automatically based on the scale free topology criterion if unspecified.}

\item{max_singleton}{Integer. The maximal singleton in the clustering.
Usually equals the number of features.}

\item{qc_plot}{Logical. Should plots be created?}

\item{min_cluster_size}{Integer. The minimum number of features in one
module.}

\item{ME_diss_thres}{Numeric. Module Eigengene Dissimilarity Threshold for
merging close modules.}

\item{n_pc}{Number of principal components and variance explained
entries to be calculated. The number of returned variance explained
entries is currently ‘min(n_pc,10)’. If given ‘n_pc’ is 
greater than 10, a warning is issued.}

\item{robust_PCs}{Should PCA be calculated on ranked data (Spearman PCA)?
Rotations will not correspond to original data if this is applied.}

\item{nb_min_varExpl}{Minimum proportion of variance explained for
returned module eigengenes. The number of PCs is capped at n_pc.}

\item{cores}{Integer. Amount of CPU cores used (<=1 : sequential)}

\item{scale}{Logical. Should data be scaled and centered?}

\item{method}{A character string specifying the method to be used for
correlation coefficients.}

\item{verbose}{Additional diagnostic messages.}
}
\value{
dendros    A list of dendrograms. For each fully separate part of the
  network an individual dendrogram.

names    A vector of feature names.

colors    A vector of numeric color coding in matching order of names
  and module eigengene names (color = 3 -> variable in ME3).

MEs    Aggregated module measures (Module eigengenes).

var_explained    Proportion of variance explained per module
  eigengene
  per principal component (max n_pc principal components are listed).

rotation    Matrix of variable loadings divided by their singular
  values. datan %*% rotation = MEs (with datan potentially scaled)

filter    Filter-Matrix as generated by the nb_filter function.
}
\description{
The Netboost clustering is performed in three subsequent steps. First, a
filter of important edges in the network is calculated. Next, pairwise
distances are calculated. Last, clustering is performed. For details see
Schlosser et al. doi...
}
\examples{
data('tcga_aml_meth_rna_chr18',  package='netboost')
results <- netboost(datan=tcga_aml_meth_rna_chr18, stepno=20L,
   soft_power=3L, min_cluster_size=10L, n_pc=2, scale=TRUE,
   ME_diss_thres=0.25, qc_plot=TRUE)

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{cpp_dist_tom}
\alias{cpp_dist_tom}
\title{Function to calcutate distance}
\usage{
cpp_dist_tom(filter, adjacency)
}
\arguments{
\item{filter}{Filter matrix}

\item{adjacency}{Vector}
}
\value{
numeric vector
}
\description{
Function to calcutate distance
}
\details{
Steps:
  1. - Sequential preparation of index and partner caches per value in filter
  2. - Parallel calculation of the distances with cached vectors
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/netboost.R
\name{tree_dendro}
\alias{tree_dendro}
\title{Calculate the dendrogram for an individual tree}
\usage{
tree_dendro(tree, datan, forest)
}
\arguments{
\item{tree}{A list with two elements. ids, which is an integer vector of
feature identifiers and rows, which is an integer vector of selected rows
in the corresponding forest}

\item{datan}{Data frame were rows correspond to samples and columns to
features.}

\item{forest}{Raw dendrogram-matrix as generated by the nb_mcupgma 
function.}
}
\value{
List of tree specific objects including dendrogram, tree data and
  features.
}
\description{
Calculate the dendrogram for an individual tree
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/netboost.R
\name{calculate_adjacency}
\alias{calculate_adjacency}
\title{Calculate network adjacencies for filter}
\usage{
calculate_adjacency(
  datan,
  filter,
  soft_power = 2,
  method = c("pearson", "kendall", "spearman"),
  cores = getOption("mc.cores", 2L)
)
}
\arguments{
\item{datan}{Data frame were rows correspond to samples and columns to
features.}

\item{filter}{Filter-Matrix as generated by the nb_filter function.}

\item{soft_power}{Integer. Exponent of the transformation. Set automatically
based on the scale free topology criterion if unspecified.}

\item{method}{A character string specifying the method to be used for
correlation coefficients.}

\item{cores}{Integer. Amount of CPU cores used (<=1 : sequential).}
}
\value{
Vector with adjacencies for the filter
}
\description{
Calculate network adjacencies for filter
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/tools.R
\name{mcupgma_exec}
\alias{mcupgma_exec}
\title{Execute a program/script from the installed MCUPGMA suite.}
\usage{
mcupgma_exec(exec = NULL, ..., console = TRUE)
}
\arguments{
\item{exec}{Name of the file of the executable.}

\item{...}{Arguments passed to mcupgma executable in order required by
program}

\item{console}{Logical. Print output to R console or fetch for return to
caller}
}
\value{
console=TRUE: exit code (0: no error). console=FALSE: STDOUT/STDERR
  output
}
\description{
Execute a program/script from the installed MCUPGMA suite.
}
\examples{
  mcupgma_exec(exec="cluster.pl", "--help")
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in src/tree_sort.cpp
\name{cpp_tree_search}
\alias{cpp_tree_search}
\title{Tree search.}
\usage{
cpp_tree_search(netboost_forest)
}
\arguments{
\item{netboost_forest}{Input-matrix (4 columns, ids in colum 0,1,3)}
}
\value{
List
}
\description{
Constraint: IDs 0 <= x (Integer)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/netboost.R
\name{nb_moduleEigengenes}
\alias{nb_moduleEigengenes}
\title{Netboost module aggregate extraction.}
\usage{
nb_moduleEigengenes(
  expr,
  colors,
  n_pc = 1,
  align = "along average",
  exclude_grey = FALSE,
  grey = if (is.numeric(colors)) 0 else "grey",
  subHubs = TRUE,
  robust = FALSE,
  trapErrors = FALSE,
  return_valid_only = trapErrors,
  soft_power = 6,
  scale = TRUE,
  verbose = 0,
  indent = 0,
  nb_min_varExpl = 0.5
)
}
\arguments{
\item{expr}{Expression data for a single set in the form of a data frame
where rows are samples and columns are genes (probes).}

\item{colors}{A vector of the same length as the number of probes in
‘expr’, giving module color for all probes (genes). Color ‘'grey'’ is
reserved for unassigned genes.     Expression}

\item{n_pc}{Number of principal components and variance explained
entries to be calculated. The number of returned variance explained entries
is currently ‘min(n_pc,10)’. If given ‘n_pc’ is greater than 10, a warning is
issued.}

\item{align}{Controls whether eigengenes, whose orientation is
undetermined, should be aligned with average expression (‘align = 'along
average'’, the default) or left as they are (‘align = ''’). Any other value
will trigger an error.}

\item{exclude_grey}{Should the improper module consisting of 'grey' genes be
excluded from the eigengenes?}

\item{grey}{Value of ‘colors’ designating the improper module. Note
that if ‘colors’ is a factor of numbers, the default value will be
incorrect.}

\item{subHubs}{Controls whether hub genes should be substituted for
missing eigengenes. If ‘TRUE’, each missing eigengene (i.e., eigengene
whose calculation failed and the error was trapped) will be replaced by a
weighted average of the most connected hub genes in the corresponding
module. If this calculation fails, or if ‘subHubs==FALSE’, the value of
‘trapErrors’ will determine whether the offending module will be removed or
whether the function will issue an error and stop.}

\item{robust}{Should PCA be calculated on ranked data (Spearman PCA)?
Rotations will not correspond to original data if this is applied.}

\item{trapErrors}{Controls handling of errors from that may arise when
there are too many ‘NA’ entries in expression data. If ‘TRUE’, errors from
calling these functions will be trapped without abnormal exit.  If ‘FALSE’,
errors will cause the function to stop. Note, however, that ‘subHubs’ takes
precedence in the sense that if ‘subHubs==TRUE’ and ‘trapErrors==FALSE’, an
error will be issued only if both the principal component and the hubgene
calculations have failed.}

\item{return_valid_only}{logical; controls whether the returned data frame of
module eigengenes contains columns corresponding only to modules whose
eigengenes or hub genes could be calculated correctly (‘TRUE’), or whether
the data frame should have columns for each of the input color labels
(‘FALSE’).}

\item{soft_power}{The power used in soft-thresholding the adjacency
matrix. Only used when the hubgene approximation is necessary because the
principal component calculation failed. It must be non-negative. The
default value should only be changed if there is a clear indication that it
leads to incorrect results.}

\item{scale}{logical; can be used to turn off scaling of the
expression data before calculating the singular value decomposition. The
scaling should only be turned off if the data has been scaled previously,
in which case the function can run a bit faster. Note however that the
function first imputes, then scales the expression data in each module. If
the expression contain missing data, scaling outside of the function and
letting the function impute missing data may lead to slightly different
results than if the data is scaled within the function.}

\item{verbose}{Controls verbosity of printed progress messages. 0 means
silent, up to (about) 5 the verbosity gradually increases.}

\item{indent}{A single non-negative integer controlling indentation of
printed messages. 0 means no indentation, each unit above that adds two
spaces.}

\item{nb_min_varExpl}{Minimum proportion of variance explained for
returned module eigengenes. Is capped at n_pc.}
}
\value{
eigengenes    Module eigengenes in a dataframe, with each column
  corresponding to one eigengene. The columns are named by the corresponding
  color with an ‘'ME'’ prepended, e.g., ‘MEturquoise’ etc. If
  ‘return_valid_only==FALSE’, module eigengenes whose calculation failed have
  all components set to ‘NA’.

averageExpr  If ‘align == 'along average'’, a dataframe containing
  average normalized expression in each module. The columns are named by the
  corresponding color with an ‘'AE'’ prepended, e.g., ‘AEturquoise’ etc.

var_explained A dataframe in which each column corresponds to a
  module, with the component ‘var_explained[PC, module]’ giving the variance
  of module ‘module’ explained by the principal component no. ‘PC’. The
  calculation is exact irrespective of the number of computed principal
  components. At most 10 variance explained values are recorded in this
  dataframe.

n_pc          A copy of the input ‘n_pc’.

validMEs     A boolean vector. Each component (corresponding to the
  columns in ‘data’) is ‘TRUE’ if the corresponding eigengene is valid, and
  ‘FALSE’ if it is invalid. Valid eigengenes include both principal
  components and their hubgene approximations. When ‘return_valid_only==FALSE’,
  by definition all returned eigengenes are valid and the entries of
  ‘validMEs’ are all ‘TRUE’.

validColors  A copy of the input colors with entries corresponding to
  invalid modules set to ‘grey’ if given, otherwise 0 if ‘colors’ is numeric
  and 'grey' otherwise.

allOK        Boolean flag signalling whether all eigengenes have been
  calculated correctly, either as principal components or as the hubgene
  average approximation.

allPC        Boolean flag signalling whether all returned eigengenes
  are principal components.

isPC         Boolean vector. Each component (corresponding to the
  columns in ‘eigengenes’) is ‘TRUE’ if the corresponding eigengene is the
  first principal component and ‘FALSE’ if it is the hubgene approximation or
  is invalid.

isHub        Boolean vector. Each component (corresponding to the
  columns in ‘eigengenes’) is ‘TRUE’ if the corresponding eigengene is the
  hubgene approximation and ‘FALSE’ if it is the first principal component or
  is invalid.

validAEs     Boolean vector. Each component (corresponding to the
  columns in ‘eigengenes’) is ‘TRUE’ if the corresponding module average
  expression is valid.

allAEOK      Boolean flag signalling whether all returned module
  average expressions contain valid data. Note that ‘return_valid_only==TRUE’
  does not imply ‘allAEOK==TRUE’: some invalid average expressions may be
  returned if their corresponding eigengenes have been calculated correctly.
}
\description{
This is a modification of WGCNA::moduleEigengenes() (version WGCNA_1.66) to
include more than the first principal component. For details see
WGCNA::moduleEigengenes().
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{cpp_filter_step}
\alias{cpp_filter_step}
\title{Single boosting step}
\usage{
cpp_filter_step(col_y)
}
\arguments{
\item{col_y}{Row in data matrix}
}
\value{
integer vector
}
\description{
Single boosting step
}
\details{
Must be initialised before using @see{filter_base}
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/RcppExports.R
\name{cpp_filter_base}
\alias{cpp_filter_base}
\title{Initialise boosting with chosen accelerator hardware (x86, AVX, FMA)}
\usage{
cpp_filter_base(data, stepno = 20L, mode_ = 2L)
}
\arguments{
\item{data}{Matrix}

\item{stepno}{Amount of steps}

\item{mode_}{Accelerator mode (0: x86, 1: FMA, 2: AVX)}
}
\value{
none
}
\description{
Initialise boosting with chosen accelerator hardware (x86, AVX, FMA)
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/netboost.R
\name{tree_search}
\alias{tree_search}
\title{Extracts independent trees from nb_mcupgma results (external wrapper for
internal C++ function)}
\usage{
tree_search(forest = NULL)
}
\arguments{
\item{forest}{Raw dendrogram-matrix as generated by the nb_mcupgma
function.}
}
\value{
List
}
\description{
Extracts independent trees from nb_mcupgma results (external wrapper for
internal C++ function)
}
\examples{
   data('tcga_aml_meth_rna_chr18',  package='netboost')
   cores <- as.integer(getOption('mc.cores', 2))
   datan <- as.data.frame(scale(tcga_aml_meth_rna_chr18, center=TRUE,
                                scale=TRUE))
   filter <- nb_filter(datan=datan, stepno=20L, until=0L, progress=1000L,
                       cores=cores,mode=2L)
   dist <- nb_dist(datan=datan, filter=filter, soft_power=3L, cores=cores)
   max_singleton = dim(tcga_aml_meth_rna_chr18)[2]
   forest <- nb_mcupgma(filter=filter, dist=dist,
                        max_singleton=max_singleton, cores=cores)
   trees <- tree_search(forest)
   str(trees[[length(trees)]])

}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/zzz.R
\name{netboostMCUPGMAPath}
\alias{netboostMCUPGMAPath}
\title{Returns the absolute path to folder with mcupgma executables and scripts.}
\usage{
netboostMCUPGMAPath()
}
\value{
Absolute path for "mcupgma" folder
}
\description{
Returns the absolute path to folder with mcupgma executables and scripts.
}

% Generated by roxygen2: do not edit by hand
% Please edit documentation in R/netboost.R
\name{nb_filter}
\alias{nb_filter}
\title{Boosting via C++ function. Parallelisation by R-package parallel with forking
(overhead of this method does not fall into account as single steps are
~10s).}
\usage{
nb_filter(
  datan,
  stepno = 20L,
  until = 0L,
  progress = 1000L,
  filter_method = c("spearman", "skip", "kendall", "boosting", "pearson"),
  cores = getOption("mc.cores", 2L),
  mode = 2L,
  verbose = getOption("verbose")
)
}
\arguments{
\item{datan}{Data frame were rows correspond to samples and columns to
features.}

\item{stepno}{Integer amount of boosting steps}

\item{until}{Stop at index/column (if 0: iterate through all columns)}

\item{progress}{Integer. If > 0, print progress after every X steps (mind:
parallel!)}

\item{filter_method}{The following filtering methods are supported:
"boosting" (non-zero coefficients in likelihood based boosting),
"skip" (no filter), "kendall" (stats::cor.test),
"spearman" (stats::cor.test), "pearson" (stats::cor.test)}

\item{cores}{Integer. Amount of CPU cores used (<=1 : sequential)}

\item{mode}{Integer. Mode (0: x86, 1: FMA, 2: AVX). Features are only
available if compiled accordingly and available on the hardware.}

\item{verbose}{Additional diagnostic messages.}
}
\value{
matrix n times 2 matrix with the indicies of the n unique entrees of
  the filter
}
\description{
Parallelisation via multicore (via 'parallel'-package). So *nix only atm.
}
\examples{
data('tcga_aml_meth_rna_chr18',  package='netboost')
 cores <- as.integer(getOption('mc.cores', 2))
 datan <- as.data.frame(scale(tcga_aml_meth_rna_chr18, center=TRUE,
 scale=TRUE))
 filter <- nb_filter(datan=datan, stepno=20L, until=0L, progress=1000L,
 cores=cores,mode=2L)
 head(filter)
 nrow(filter)/(ncol(datan)*(ncol(datan)-1)/2) # proportion of potential undirected edges

}
